/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

/*
 *  ComboBox example:
 *    Creates a simple combobox.
 */
#include <stdio.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <pimglib.h>
#include <picowidget.h>
#include <display.h>
#include <eventloop.h>

#define NORMAL_FONT "-picopeta-simputer-medium-r-normal--11-*-*-*-p-*-fontspecific-0"

px_display *disp;
px_eventloop *eloop;
px_widget *toplvl, *cbox, *butt;
px_color col, acol, gcol;

Bool butt_callback(px_widget *wdgt, px_event *ev)
{
	cbox->set_size(cbox, 160, 20);
	combobox_set_visible_num_of_options(cbox, 5);
	return(False);
}

int main(int av, char **ac)
{
	int i;
	char str[32];

	disp = display_get_display();
	
	if(disp->open_display(disp, (char *)getenv("DISPLAY"))) {
		// Create the toplevel window
		toplvl = new_widget(TOPLEVEL,NULL,0,0,240,270,"TOPLEVEL_TAG");
		toplvl->specific.toplevel.set_title(toplvl, "Example");
		toplvl->redraw(toplvl);
		toplvl->show(toplvl);

		// Create the text listbox and add two columns
		cbox = new_widget(COMBOBOX, toplvl, 30, 10, 100, 100, NULL);
		cbox->specific.combobox.add_option(cbox, "One", False);
		cbox->specific.combobox.add_option(cbox, "Two", False);
		cbox->specific.combobox.add_option(cbox, "Three", False);
		cbox->specific.combobox.add_option(cbox, "Four", True);
		cbox->redraw(cbox);
		cbox->show(cbox);

		butt = new_widget(BUTTON, toplvl, 50, 140, 140, 30, "Hello");
		butt->specific.button.set_font(butt, NORMAL_FONT);
		butt->specific.button.set_text(butt, "Change Combo Width");
		butt->set_border_type(butt, BEVELLED_BORDER);
		butt->callbacks[BUTTON_RELEASED] = butt_callback;
		butt->redraw(butt);
		butt->show(butt);

		// Get into eventloop
		eloop = eventloop_get_eventloop();
		eloop->loop(eloop);

		display_destroy();
	} else {
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
	exit(0);
}
