/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include<stdio.h>
#include<string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <pimglib.h>
#include <picowidget.h>
#include <display.h>
#include <eventloop.h>

#define NORMAL_FONT "-picopeta-simputer-medium-r-normal--11-*-*-*-p-*-fontspecific-0"

px_display *display;
px_eventloop *eloop;
px_widget *toplevel, *listbox;

Bool listbox_press_callback(px_widget* widget, px_event* event)
{
	printf("Element selected : %d, Tagname : %s\n", 
					listbox->specific.listbox.event_within_index, widget->tag);
	
	widget->set_border_type(widget, RECTANGLE_BORDER);
     widget->redraw(widget);
	widget->show(widget);
		
	return False;
}

Bool listbox_release_callback(px_widget* widget, px_event* event)
{
	widget->set_border_type(widget, NO_BORDER);
     widget->redraw(widget);
	widget->show(widget);
		
	return False;
}

#define NUM_ENTRY 15

int main(int av, char **ac)
{
	int i;
	char mesg[50];
	px_widget *frame, *label;
	display = display_get_display();
	
	if(display->open_display(display, (char *)getenv("DISPLAY"))) {
		// Create the toplevel window
		toplevel = new_widget(TOPLEVEL, NULL, 0, 0, 240, 270, NULL);
		toplevel->specific.toplevel.set_title(toplevel, "ListboxDemo");
		toplevel->redraw(toplevel);
		toplevel->show(toplevel);

		// Add a listbox
		listbox = new_widget(LISTBOX, toplevel, 10, 10, 230, 250, "");
		listbox->redraw(listbox);
		listbox->show(listbox);

		// Add some labels to the end of listbox
		for(i=0; i<NUM_ENTRY; i++) {
			sprintf(mesg, "tag_%d", i+1);
			frame = new_widget(FRAME, listbox, 0, 0, 200, 20, mesg);
			frame->callbacks[BUTTON_PRESSED] = listbox_press_callback;
			frame->callbacks[BUTTON_RELEASED] = listbox_release_callback;
			frame->redraw(frame);
			frame->show(frame);
			
			label = new_widget(LABEL, frame, 0, 0, 220, 20, "");
			label->specific.label.set_font(label, NORMAL_FONT);
			label->specific.label.set_justification(label, JUSTIFY_LEFT);
			sprintf(mesg, "Label %d", i+1);
			label->specific.label.set_text(label, mesg);
			label->redraw(label);
			label->show(label);

			listbox->specific.listbox.set_child(listbox, frame, 
										listbox->specific.listbox.no_of_children);
		}
		listbox->redraw(listbox);
		listbox->show(listbox);
			
		// Get into eventloop
		eloop = eventloop_get_eventloop();
		eloop->loop(eloop);

		display_destroy();
	} else {
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
	exit(0);
}
