/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include<stdio.h>
#include<string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <pimglib.h>
#include <picowidget.h>
#include <display.h>
#include <eventloop.h>
#include <acctrl.h>

#define NORMAL_FONT "-picopeta-simputer-medium-r-normal--11-*-*-*-p-*-fontspecific-0"

px_display *display;
px_eventloop *eloop;
px_widget *toplevel, *listbox;

Bool toplevel_configure_event(px_widget *widget, px_event *event)
{
	listbox->specific.listbox.see(listbox, 0);

	if(event->xev->xconfigure.height==175) {
		listbox->set_size(listbox, 230, 155);
	} else {
		listbox->set_size(listbox, 230, 250);
	}

	listbox->redraw(listbox);
	listbox->show(listbox);

	return False;
}

int main(int av, char **ac)
{
	int i;
	char mesg[50];
	px_widget *frame, *label[3], *entry[6];
	display = display_get_display();
	
	if(display->open_display(display, (char *)getenv("DISPLAY"))) {
		// Create the toplevel window
		toplevel = new_widget(TOPLEVEL, NULL, 0, 0, 240, 270, NULL);
		ac_init_app(display_get_Xdisplay(), toplevel->win);
		toplevel->callbacks[CONFIGURE] = toplevel_configure_event;
		toplevel->specific.toplevel.set_title(toplevel, "ScrollFrame");
		toplevel->redraw(toplevel);
		toplevel->show(toplevel);

		// Add a listbox
		listbox = new_widget(LISTBOX, toplevel, 10, 10, 230, 250, "");
		listbox->redraw(listbox);
		listbox->show(listbox);

		// Add a scrollable frame
		frame = new_widget(FRAME, listbox, 10, 10, 220, 248, "");
		listbox->specific.listbox.set_child(listbox, frame, 0);
		frame->redraw(frame);
		frame->show(frame);

		// Add contents to the frame
		label[0] = new_widget(LABEL, frame, 10, 10, 60, 20, "");
		label[0]->specific.label.set_justification(label[0], JUSTIFY_LEFT);
		label[0]->specific.label.set_font(label[0], NORMAL_FONT);
		label[0]->specific.label.set_text(label[0], "Name");
		label[0]->redraw(label[0]);
		label[0]->show(label[0]);

		entry[0] = new_widget(ENTRY, frame, 80, 7, 120, 25, "");
		entry[0]->redraw(entry[0]);
		entry[0]->show(entry[0]);
		
		label[1] = new_widget(LABEL, frame, 10, 40, 60, 20, "");
		label[1]->specific.label.set_justification(label[1], JUSTIFY_LEFT);
		label[1]->specific.label.set_font(label[1], NORMAL_FONT);
		label[1]->specific.label.set_text(label[1], "Address");
		label[1]->redraw(label[1]);
		label[1]->show(label[1]);

		entry[1] = new_widget(ENTRY, frame, 80, 37, 120, 25, "");
		entry[1]->redraw(entry[1]);
		entry[1]->show(entry[1]);
		entry[2] = new_widget(ENTRY, frame, 80, 67, 120, 25, "");
		entry[2]->redraw(entry[2]);
		entry[2]->show(entry[2]);
		entry[3] = new_widget(ENTRY, frame, 80, 97, 120, 25, "");
		entry[3]->redraw(entry[3]);
		entry[3]->show(entry[3]);
		entry[4] = new_widget(ENTRY, frame, 80, 127, 120, 25, "");
		entry[4]->redraw(entry[4]);
		entry[4]->show(entry[4]);
		
		label[2] = new_widget(LABEL, frame, 10, 160, 70, 20, "");
		label[2]->specific.label.set_justification(label[2], JUSTIFY_LEFT);
		label[2]->specific.label.set_font(label[2], NORMAL_FONT);
		label[2]->specific.label.set_text(label[2], "Phone No.");
		label[2]->redraw(label[2]);
		label[2]->show(label[2]);

		entry[5] = new_widget(ENTRY, frame, 80, 157, 120, 25, "");
		entry[5]->redraw(entry[5]);
		entry[5]->show(entry[5]);
		
		// Show the keyboard
		ac_control_win(AC_CMD_SHOW_INPUT, "", display_get_Xdisplay(), toplevel->win);

		// Get into eventloop
		eloop = eventloop_get_eventloop();
		usleep(100000);
		eloop->focus(eloop, entry[0]);
		eloop->loop(eloop);

		display_destroy();
	} else {
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
	exit(0);
}
