/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "buttonpage.h"
#include "ui.h"
#include <image.h>
extern px_pixmap background_image;
ButtonPage* buttonpage_create()
{
	int count;
	ButtonPage* buttonpage = (ButtonPage*)malloc(sizeof(ButtonPage));
	UI* ui = ui_get_ui();
	px_color col;
	px_color active_col;

	col.type = TRANSPARENT;
	active_col.type = SOLID;
	widget_xcolor_from_str(&(active_col.first_color), "black");

	buttonpage->mainframe = new_widget(FRAME, ui->toplevel, 0, 0, 640, 480, NULL);
	buttonpage->mainframe->set_background_pixmap_from_pixmap(buttonpage->mainframe, ui_get_pixmap(ui, BACKGROUND));
	buttonpage->mainframe->redraw(buttonpage->mainframe);

	buttonpage->borders = new_widget(LABEL, buttonpage->mainframe, 10, 10, 320, 30, "Border Label");
	buttonpage->borders->specific.label.set_font(buttonpage->borders, BOLD_FONT);
	buttonpage->borders->specific.label.set_text(buttonpage->borders, "1. Buttons with different types of borders.");
	buttonpage->borders->specific.label.set_justification(buttonpage->borders, JUSTIFY_LEFT);
	buttonpage->borders->redraw(buttonpage->borders);

	buttonpage->borderless = new_widget(BUTTON, buttonpage->mainframe, 20, 50, 70, 30, "Borderless");
	buttonpage->borderless->specific.button.set_font(buttonpage->borderless, NORMAL_FONT);
	buttonpage->borderless->specific.button.set_text(buttonpage->borderless, "No Border");
	buttonpage->borderless->set_background_color(buttonpage->borderless, &col);
	buttonpage->borderless->specific.button.set_active_background_color(buttonpage->borderless, &active_col);
	buttonpage->borderless->specific.button.set_active_font_color(buttonpage->borderless, "white");
	buttonpage->borderless->redraw(buttonpage->borderless);
			
	buttonpage->rectangle = new_widget(BUTTON, buttonpage->mainframe, 120, 50, 90, 30, "Rectangle");
	buttonpage->rectangle->specific.button.set_font(buttonpage->rectangle, NORMAL_FONT);
	buttonpage->rectangle->specific.button.set_text(buttonpage->rectangle, "Rectangle");
	buttonpage->rectangle->set_border_type(buttonpage->rectangle, RECTANGLE_BORDER);
	buttonpage->rectangle->set_background_color(buttonpage->rectangle, &col);
	buttonpage->rectangle->specific.button.set_active_background_color(buttonpage->rectangle, &active_col);
	buttonpage->rectangle->specific.button.set_active_font_color(buttonpage->rectangle, "white");
	buttonpage->rectangle->redraw(buttonpage->rectangle);
	
	buttonpage->elliptic = new_widget(BUTTON, buttonpage->mainframe, 230, 50, 90, 30, "Elliptic");
	buttonpage->elliptic->specific.button.set_font(buttonpage->elliptic, NORMAL_FONT);
	buttonpage->elliptic->specific.button.set_text(buttonpage->elliptic, "Elliptic");
	buttonpage->elliptic->set_background_color(buttonpage->elliptic, &col);
	buttonpage->elliptic->specific.button.set_active_background_color(buttonpage->elliptic, &active_col);
	buttonpage->elliptic->specific.button.set_active_font_color(buttonpage->elliptic, "white");
	buttonpage->elliptic->set_border_type(buttonpage->elliptic, ELLIPTIC_BORDER);
	buttonpage->elliptic->redraw(buttonpage->elliptic);

	buttonpage->bevelled = new_widget(BUTTON, buttonpage->mainframe, 340, 50, 90, 30, "Bevelled");
	buttonpage->bevelled->specific.button.set_font(buttonpage->bevelled, NORMAL_FONT);
	buttonpage->bevelled->specific.button.set_text(buttonpage->bevelled, "Bevelled");
	buttonpage->bevelled->set_border_type(buttonpage->bevelled, BEVELLED_BORDER);
	buttonpage->bevelled->specific.button.set_active_background_color(buttonpage->bevelled, &active_col);
	buttonpage->bevelled->specific.button.set_active_font_color(buttonpage->bevelled, "white");
	buttonpage->bevelled->set_background_color(buttonpage->bevelled, &col);
	buttonpage->bevelled->redraw(buttonpage->bevelled);

	// Buttons with images.
	buttonpage->images_lbl = new_widget(LABEL, buttonpage->mainframe, 10, 90, 320, 30, "Images Label");
	buttonpage->images_lbl->specific.label.set_font(buttonpage->images_lbl, BOLD_FONT);
	buttonpage->images_lbl->specific.label.set_text(buttonpage->images_lbl, "2. Buttons with images.");
	buttonpage->images_lbl->specific.label.set_justification(buttonpage->images_lbl, JUSTIFY_LEFT);
	buttonpage->images_lbl->redraw(buttonpage->images_lbl);

	buttonpage->triangle = new_widget(BUTTON, buttonpage->mainframe, 10, 125, 70, 30, "Triangle");
	buttonpage->triangle->specific.button.set_normal_pixmap_from_pixmap(buttonpage->triangle,
			ui_get_pixmap(ui, TRIANGLE));
	buttonpage->triangle->specific.button.set_active_pixmap_from_pixmap(buttonpage->triangle, 
			ui_get_pixmap(ui, TRIANGLE_A));
	buttonpage->triangle->set_background_color(buttonpage->triangle, &col);
	buttonpage->triangle->redraw(buttonpage->triangle);
			
	buttonpage->squares = new_widget(BUTTON, buttonpage->mainframe, 110, 125, 70, 30, NULL);
	buttonpage->squares->specific.button.set_normal_pixmap_from_pixmap(buttonpage->squares, 
			ui_get_pixmap(ui, SQUARES));
	buttonpage->squares->specific.button.set_active_pixmap_from_pixmap(buttonpage->squares, 
			ui_get_pixmap(ui, SQUARES_A));
	buttonpage->squares->set_background_color(buttonpage->squares, &col);
	buttonpage->squares->redraw(buttonpage->squares);
	
	buttonpage->circles = new_widget(BUTTON, buttonpage->mainframe, 210, 125, 70, 30, "Circles");
	buttonpage->circles->specific.button.set_normal_pixmap_from_pixmap(buttonpage->circles, 
			ui_get_pixmap(ui, CIRCLES));
	buttonpage->circles->specific.button.set_active_pixmap_from_pixmap(buttonpage->circles, 
			ui_get_pixmap(ui, CIRCLES_A));
	buttonpage->circles->set_background_color(buttonpage->circles, &col);
	buttonpage->circles->redraw(buttonpage->circles);

	buttonpage->hexagon = new_widget(BUTTON, buttonpage->mainframe, 310, 125, 70, 30, "Hexagon");
	buttonpage->hexagon->specific.button.set_normal_pixmap_from_pixmap(buttonpage->hexagon, 
			ui_get_pixmap(ui, HEXAGON));
	buttonpage->hexagon->specific.button.set_active_pixmap_from_pixmap(buttonpage->hexagon, 
			ui_get_pixmap(ui, HEXAGON_A));
	buttonpage->hexagon->set_background_color(buttonpage->hexagon, &col);
	buttonpage->hexagon->redraw(buttonpage->hexagon);

	// Buttons with images and event mask = EVENT_MASK.
	buttonpage->mask_images_lbl = new_widget(LABEL, buttonpage->mainframe, 10, 170, 350, 30, "Images with Mask");
	buttonpage->mask_images_lbl->specific.label.set_font(buttonpage->mask_images_lbl, BOLD_FONT);
	buttonpage->mask_images_lbl->specific.label.set_text(buttonpage->mask_images_lbl, 
			"3. Buttons with event type set to EVENT_MASK.");
	buttonpage->mask_images_lbl->specific.label.set_justification(buttonpage->mask_images_lbl, JUSTIFY_LEFT);
	buttonpage->mask_images_lbl->redraw(buttonpage->mask_images_lbl);

	buttonpage->mask_triangle = new_widget(BUTTON, buttonpage->mainframe, 10, 200, 70, 30, "M-Triangle");
	buttonpage->mask_triangle->specific.button.set_normal_pixmap_from_pixmap(buttonpage->mask_triangle, 
			ui_get_pixmap(ui, TRIANGLE));
	buttonpage->mask_triangle->specific.button.set_active_pixmap_from_pixmap(buttonpage->mask_triangle, 
			ui_get_pixmap(ui, TRIANGLE_A));
	buttonpage->mask_triangle->set_background_color(buttonpage->mask_triangle, &col);
	buttonpage->mask_triangle->set_event_mask(buttonpage->mask_triangle, EVENT_MASK);
	buttonpage->mask_triangle->redraw(buttonpage->mask_triangle);
			
	buttonpage->mask_squares = new_widget(BUTTON, buttonpage->mainframe, 110, 200, 70, 30, "M-Square");
	buttonpage->mask_squares->specific.button.set_normal_pixmap_from_pixmap(buttonpage->mask_squares, 
			ui_get_pixmap(ui, SQUARES));
	buttonpage->mask_squares->specific.button.set_active_pixmap_from_pixmap(buttonpage->mask_squares, 
			ui_get_pixmap(ui, SQUARES_A));
	buttonpage->mask_squares->set_background_color(buttonpage->mask_squares, &col);
	buttonpage->mask_squares->set_event_mask(buttonpage->mask_squares, EVENT_MASK);
	buttonpage->mask_squares->redraw(buttonpage->mask_squares);
	
	buttonpage->mask_circles = new_widget(BUTTON, buttonpage->mainframe, 210, 200, 70, 30, "M-Circles");
	buttonpage->mask_circles->specific.button.set_normal_pixmap_from_pixmap(buttonpage->mask_circles, 
			ui_get_pixmap(ui, CIRCLES));
	buttonpage->mask_circles->specific.button.set_active_pixmap_from_pixmap(buttonpage->mask_circles, 
			ui_get_pixmap(ui, CIRCLES_A));
	buttonpage->mask_circles->set_background_color(buttonpage->mask_circles, &col);
	buttonpage->mask_circles->set_event_mask(buttonpage->mask_circles, EVENT_MASK);
	buttonpage->mask_circles->redraw(buttonpage->mask_circles);

	buttonpage->mask_hexagon = new_widget(BUTTON, buttonpage->mainframe, 310, 200, 70, 30, "M-Hexagon");
	buttonpage->mask_hexagon->specific.button.set_normal_pixmap_from_pixmap(buttonpage->mask_hexagon, 
			ui_get_pixmap(ui, HEXAGON));
	buttonpage->mask_hexagon->specific.button.set_active_pixmap_from_pixmap(buttonpage->mask_hexagon, 
			ui_get_pixmap(ui, HEXAGON_A));
	buttonpage->mask_hexagon->set_background_color(buttonpage->mask_hexagon, &col);
	buttonpage->mask_hexagon->set_event_mask(buttonpage->mask_hexagon, EVENT_MASK);
	buttonpage->mask_hexagon->redraw(buttonpage->mask_hexagon);

	// Overlapping buttons.
	buttonpage->overlap_lbl = new_widget(LABEL, buttonpage->mainframe, 10, 250, 350, 30, "Overlap Label");
	buttonpage->overlap_lbl->specific.label.set_font(buttonpage->overlap_lbl, BOLD_FONT);
	buttonpage->overlap_lbl->specific.label.set_text(buttonpage->overlap_lbl, 
			"4. Overlapping buttons.");
	buttonpage->overlap_lbl->specific.label.set_justification(buttonpage->overlap_lbl, JUSTIFY_LEFT);
	buttonpage->overlap_lbl->redraw(buttonpage->overlap_lbl);

	buttonpage->overlap_solid = new_widget(LABEL, buttonpage->mainframe, 20, 275, 350, 30, "O-Solid Label");
	buttonpage->overlap_solid->specific.label.set_font(buttonpage->overlap_solid, NORMAL_FONT);
	buttonpage->overlap_solid->specific.label.set_text(buttonpage->overlap_solid, 
			"a. EVENT SOLID");
	buttonpage->overlap_solid->specific.label.set_justification(buttonpage->overlap_solid, JUSTIFY_LEFT);
	buttonpage->overlap_solid->redraw(buttonpage->overlap_solid);

	buttonpage->overlap_mask = new_widget(LABEL, buttonpage->mainframe, 320, 275, 350, 30, "O-Mask Label");
	buttonpage->overlap_mask->specific.label.set_font(buttonpage->overlap_mask, NORMAL_FONT);
	buttonpage->overlap_mask->specific.label.set_text(buttonpage->overlap_mask, 
			"b. EVENT MASK");
	buttonpage->overlap_mask->specific.label.set_justification(buttonpage->overlap_mask, JUSTIFY_LEFT);
	buttonpage->overlap_mask->redraw(buttonpage->overlap_mask);

	col.type = SOLID;
	for (count = 0; count < 3; count++)
	{
		char lbl[3];
		char tag[100];
		int index;

		if (count == 0)
			index = 0;
		else if (count == 1)
			index = 2;
		else if (count == 2)
			index = 1;
		if (index % 2)
		{
			widget_xcolor_from_str(&(col.first_color), "#d9ccc1");
		}
		else
		{
			widget_xcolor_from_str(&(col.first_color), "#64a9a0");
		}

		sprintf(lbl, "%d", index+1);
		sprintf(tag, "Solid-%d", index+1);
		buttonpage->overlaps[index] = new_widget(BUTTON, buttonpage->mainframe, 20 + 60*index, 310, 70, 30, tag);
		buttonpage->overlaps[index]->specific.button.set_font(buttonpage->overlaps[index], NORMAL_FONT);
		buttonpage->overlaps[index]->specific.button.set_text(buttonpage->overlaps[index], lbl);
		buttonpage->overlaps[index]->set_background_color(buttonpage->overlaps[index], &col);
		buttonpage->overlaps[index]->specific.button.set_active_background_color(buttonpage->overlaps[index], &active_col);
		buttonpage->overlaps[index]->specific.button.set_active_font_color(buttonpage->overlaps[index], "white");
		buttonpage->overlaps[index]->set_border_type(buttonpage->overlaps[index], ELLIPTIC_BORDER);
		buttonpage->overlaps[index]->redraw(buttonpage->overlaps[index]);
	}


	
	for (count = 0; count < 3; count++)
	{
		char lbl[3];
		char tag[100];
		int index;
		
		if (count == 0)
			index = 0;
		else if (count == 1)
			index = 2;
		else if (count == 2)
			index = 1;
			
		sprintf(lbl, "%d", index+1);
		sprintf(tag, "Solid-%d", index+1);
		buttonpage->masked_overlaps[index] = new_widget(BUTTON, buttonpage->mainframe, 320 + 60*index, 310, 70, 30, NULL);
		buttonpage->masked_overlaps[index]->specific.button.set_font(buttonpage->masked_overlaps[index], NORMAL_FONT);
		buttonpage->masked_overlaps[index]->specific.button.set_text(buttonpage->masked_overlaps[index], lbl);
	
		if (index % 2)
		{
			widget_xcolor_from_str(&(col.first_color), "#d9ccc1");
		}
		else
		{
			widget_xcolor_from_str(&(col.first_color), "#64a9a0");
		}
		buttonpage->masked_overlaps[index]->set_background_color(buttonpage->masked_overlaps[index], &col);
		buttonpage->masked_overlaps[index]->specific.button.set_active_background_color(
				buttonpage->masked_overlaps[index], &active_col);
		buttonpage->masked_overlaps[index]->specific.button.set_active_font_color(buttonpage->masked_overlaps[index],
				"white");
		buttonpage->masked_overlaps[index]->set_border_type(buttonpage->masked_overlaps[index], ELLIPTIC_BORDER);
		buttonpage->masked_overlaps[index]->set_event_mask(buttonpage->masked_overlaps[index], EVENT_MASK);
		buttonpage->masked_overlaps[index]->redraw(buttonpage->masked_overlaps[index]);
	}
	
	col.type = TRANSPARENT;

	// Auto repeat
	buttonpage->auto_repeat_lbl = new_widget(LABEL, buttonpage->mainframe, 10, 360, 320, 30, "Auto Repeat Label");
	buttonpage->auto_repeat_lbl->specific.label.set_font(buttonpage->auto_repeat_lbl, NORMAL_FONT);
	buttonpage->auto_repeat_lbl->specific.label.set_text(buttonpage->auto_repeat_lbl, "5. This button auto repeats.");
	buttonpage->auto_repeat_lbl->specific.label.set_justification(buttonpage->auto_repeat_lbl, JUSTIFY_LEFT);
	buttonpage->auto_repeat_lbl->redraw(buttonpage->auto_repeat_lbl);

	buttonpage->auto_repeat = new_widget(BUTTON, buttonpage->mainframe, 20, 395, 90, 30, "Auto");
	buttonpage->auto_repeat->specific.button.set_font(buttonpage->auto_repeat, NORMAL_FONT);
	buttonpage->auto_repeat->specific.button.set_text(buttonpage->auto_repeat, "Press me");
	buttonpage->auto_repeat->set_border_type(buttonpage->auto_repeat, BEVELLED_BORDER);
	buttonpage->auto_repeat->specific.button.set_active_background_color(buttonpage->auto_repeat, &active_col);
	buttonpage->auto_repeat->specific.button.set_active_font_color(buttonpage->auto_repeat, "white");
	buttonpage->auto_repeat->set_background_color(buttonpage->auto_repeat, &col);
	buttonpage->auto_repeat->callbacks[BUTTON_PRESSED] = buttonpage_auto_repeat_press;
	buttonpage->auto_repeat->callbacks[BUTTON_RELEASED] = buttonpage_auto_repeat_released;
	buttonpage->auto_repeat->specific.button.set_auto_repeat(buttonpage->auto_repeat, True);
	buttonpage->auto_repeat->specific.button.set_auto_repeat_speed(buttonpage->auto_repeat, 1);
	buttonpage->auto_repeat->redraw(buttonpage->auto_repeat);

	buttonpage->auto_repeat_result = new_widget(LABEL, buttonpage->mainframe, 120, 395, 250, 30, "Result");
	buttonpage->auto_repeat_result->specific.label.set_font(buttonpage->auto_repeat_result, NORMAL_FONT);
	buttonpage->auto_repeat_result->specific.label.set_text(buttonpage->auto_repeat_result, 
			"The button auto repeated 0 times.");
	buttonpage->auto_repeat_result->specific.label.set_justification(buttonpage->auto_repeat_result, JUSTIFY_LEFT);
	buttonpage->auto_repeat_result->set_background_color(buttonpage->auto_repeat_result, &col);
	buttonpage->auto_repeat_result->redraw(buttonpage->auto_repeat_result);

	buttonpage->message = new_widget(LABEL, buttonpage->mainframe, 10, 440, 360, 30, "Message");
	buttonpage->message->specific.label.set_font(buttonpage->message, SMALL_FONT);
	buttonpage->message->specific.label.set_text(buttonpage->message, 
			"Look at buttonpage.c for the implementation of this page.");
	buttonpage->message->specific.label.set_justification(buttonpage->message, JUSTIFY_LEFT);
	buttonpage->message->redraw(buttonpage->message);

	buttonpage->back = new_widget(BUTTON, buttonpage->mainframe, 540, 440, 70, 30, "Back");
	buttonpage->back->specific.button.set_font(buttonpage->back, BOLD_FONT);
	buttonpage->back->specific.button.set_text(buttonpage->back, "Back");
	buttonpage->back->set_border_type(buttonpage->back, BEVELLED_BORDER);
	buttonpage->back->specific.button.set_active_background_color(buttonpage->back, &active_col);
	buttonpage->back->specific.button.set_active_font_color(buttonpage->back, "white");
	buttonpage->back->set_background_color(buttonpage->back, &col);
	buttonpage->back->redraw(buttonpage->back);
	buttonpage->back->callbacks[BUTTON_RELEASED] = buttonpage_back_released;

	return buttonpage;
}

unsigned int no_of_repeats = 0;

Bool buttonpage_auto_repeat_press(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ButtonPage* b = ui->buttonpage;

	if (b != NULL)
	{
		char msg[100];

		no_of_repeats++;
		sprintf(msg, "This button auto repeated %d times.", no_of_repeats);
		b->auto_repeat_result->specific.label.set_text(b->auto_repeat_result, msg);
		b->auto_repeat_result->redraw(b->auto_repeat_result);
		b->auto_repeat_result->show(b->auto_repeat_result);
	}

	return True;
}

Bool buttonpage_auto_repeat_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ButtonPage* b = ui->buttonpage;

	if (b != NULL)
	{
		char msg[100];

		no_of_repeats = 0;
		sprintf(msg, "This button auto repeated %d times.", no_of_repeats);
		b->auto_repeat_result->specific.label.set_text(b->auto_repeat_result, msg);
		b->auto_repeat_result->redraw(b->auto_repeat_result);
		b->auto_repeat_result->show(b->auto_repeat_result);
	}

	return True;
}

Bool buttonpage_back_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ui_hide(ui, BUTTONPAGE);
	ui_show(ui, INDEXPAGE);

	return True;
}
