/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __BUTTONPAGE_H
#define __BUTTONPAGE_H

#include <picowidget.h>

typedef struct _buttonpage ButtonPage;

struct _buttonpage
{
	px_widget* mainframe;
	px_widget* borders, *borderless, *rectangle, *elliptic, *bevelled;
	px_widget* images_lbl, *triangle, *squares, *circles, *hexagon;
	px_widget* mask_images_lbl, *mask_triangle, *mask_squares, *mask_circles, *mask_hexagon;
	px_widget* overlap_lbl, *overlap_solid, *overlap_mask, *overlaps[3], *masked_overlaps[3];
	px_widget* auto_repeat_lbl, *auto_repeat, *auto_repeat_result;
	px_widget* message;
	px_widget* back;
};

ButtonPage* buttonpage_create();

Bool buttonpage_auto_repeat_press(px_widget*, px_event*);
Bool buttonpage_auto_repeat_released(px_widget*, px_event*);

Bool buttonpage_back_released(px_widget*, px_event*);
#endif
