/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "checkbuttonpage.h"
#include "ui.h"
#include <image.h>
extern px_pixmap background_image;
CheckbuttonPage* checkbuttonpage_create()
{
	int count;
	CheckbuttonPage* checkbuttonpage = (CheckbuttonPage*)malloc(sizeof(CheckbuttonPage));
	UI* ui = ui_get_ui();
	px_color col;
	px_color active_col;

	col.type = TRANSPARENT;
	active_col.type = SOLID;
	widget_xcolor_from_str(&(active_col.first_color), "black");

	checkbuttonpage->mainframe = new_widget(FRAME, ui->toplevel, 0, 0, 640, 480, NULL);
	checkbuttonpage->mainframe->set_background_pixmap_from_pixmap(checkbuttonpage->mainframe, ui_get_pixmap(ui, BACKGROUND));
	checkbuttonpage->mainframe->redraw(checkbuttonpage->mainframe);

	// Checkbuttons with text.
	checkbuttonpage->fonts_lbl = new_widget(LABEL, checkbuttonpage->mainframe, 10, 10, 320, 30, NULL);
	checkbuttonpage->fonts_lbl->specific.label.set_font(checkbuttonpage->fonts_lbl, BOLD_FONT); 
	checkbuttonpage->fonts_lbl->specific.label.set_text(checkbuttonpage->fonts_lbl, "1. CheckButtons with different fonts.");
	checkbuttonpage->fonts_lbl->specific.label.set_justification(checkbuttonpage->fonts_lbl, JUSTIFY_LEFT);
	checkbuttonpage->fonts_lbl->redraw(checkbuttonpage->fonts_lbl);

	checkbuttonpage->tiny = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 10, 50, 70, 30, NULL);
	checkbuttonpage->tiny->specific.checkbutton.set_font(checkbuttonpage->tiny, TINY_FONT);
	checkbuttonpage->tiny->specific.checkbutton.set_text(checkbuttonpage->tiny, "Tiny");
	checkbuttonpage->tiny->set_background_color(checkbuttonpage->tiny, &col);
	checkbuttonpage->tiny->redraw(checkbuttonpage->tiny);
			
	checkbuttonpage->small = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 110, 50, 70, 30, NULL);
	checkbuttonpage->small->specific.checkbutton.set_font(checkbuttonpage->small, SMALL_FONT);
	checkbuttonpage->small->specific.checkbutton.set_text(checkbuttonpage->small, "Small");
	checkbuttonpage->small->set_background_color(checkbuttonpage->small, &col);
	checkbuttonpage->small->redraw(checkbuttonpage->small);
	
	checkbuttonpage->normal = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 210, 50, 70, 30, NULL);
	checkbuttonpage->normal->specific.checkbutton.set_font(checkbuttonpage->normal, NORMAL_FONT);
	checkbuttonpage->normal->specific.checkbutton.set_text(checkbuttonpage->normal, "Normal");
	checkbuttonpage->normal->set_background_color(checkbuttonpage->normal, &col);
	checkbuttonpage->normal->redraw(checkbuttonpage->normal);

	checkbuttonpage->bold = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 310, 50, 70, 30, NULL);
	checkbuttonpage->bold->specific.checkbutton.set_font(checkbuttonpage->bold, BOLD_FONT);
	checkbuttonpage->bold->specific.checkbutton.set_text(checkbuttonpage->bold, "Bold");
	checkbuttonpage->bold->set_background_color(checkbuttonpage->bold, &col);
	checkbuttonpage->bold->redraw(checkbuttonpage->bold);

	checkbuttonpage->large = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 410, 50, 70, 30, NULL);
	checkbuttonpage->large->specific.checkbutton.set_font(checkbuttonpage->large, LARGE_FONT);
	checkbuttonpage->large->specific.checkbutton.set_text(checkbuttonpage->large, "Large");
	checkbuttonpage->large->set_background_color(checkbuttonpage->large, &col);
	checkbuttonpage->large->redraw(checkbuttonpage->large);
	
	// Buttons with images.
	checkbuttonpage->images_lbl = new_widget(LABEL, checkbuttonpage->mainframe, 10, 90, 320, 30, NULL);
	checkbuttonpage->images_lbl->specific.label.set_font(checkbuttonpage->images_lbl, BOLD_FONT);
	checkbuttonpage->images_lbl->specific.label.set_text(checkbuttonpage->images_lbl, "2. CheckButtons with images.");
	checkbuttonpage->images_lbl->specific.label.set_justification(checkbuttonpage->images_lbl, JUSTIFY_LEFT);
	checkbuttonpage->images_lbl->redraw(checkbuttonpage->images_lbl);

	checkbuttonpage->triangle = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 10, 125, 70, 30, NULL);
	checkbuttonpage->triangle->specific.checkbutton.set_normal_pixmap_from_pixmap(checkbuttonpage->triangle, 
			ui_get_pixmap(ui, TRIANGLE));
	checkbuttonpage->triangle->set_background_color(checkbuttonpage->triangle, &col);
	checkbuttonpage->triangle->redraw(checkbuttonpage->triangle);
			
	checkbuttonpage->squares = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 110, 125, 70, 30, NULL);
	checkbuttonpage->squares->specific.checkbutton.set_normal_pixmap_from_pixmap(checkbuttonpage->squares,
			ui_get_pixmap(ui, SQUARES));
	checkbuttonpage->squares->set_background_color(checkbuttonpage->squares, &col);
	checkbuttonpage->squares->redraw(checkbuttonpage->squares);
	
	checkbuttonpage->circles = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 210, 125, 70, 30, NULL);
	checkbuttonpage->circles->specific.checkbutton.set_normal_pixmap_from_pixmap(checkbuttonpage->circles,
			ui_get_pixmap(ui, CIRCLES));
	checkbuttonpage->circles->set_background_color(checkbuttonpage->circles, &col);
	checkbuttonpage->circles->redraw(checkbuttonpage->circles);

	checkbuttonpage->hexagon = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 310, 125, 70, 30, NULL);
	checkbuttonpage->hexagon->specific.checkbutton.set_normal_pixmap_from_pixmap(checkbuttonpage->hexagon, 
			ui_get_pixmap(ui, HEXAGON));
	checkbuttonpage->hexagon->set_background_color(checkbuttonpage->hexagon, &col);
	checkbuttonpage->hexagon->redraw(checkbuttonpage->hexagon);

	// Buttons with no indicator.
	checkbuttonpage->no_indicator_lbl = new_widget(LABEL, checkbuttonpage->mainframe, 10, 170, 320, 30, NULL);
	checkbuttonpage->no_indicator_lbl->specific.label.set_font(checkbuttonpage->no_indicator_lbl, BOLD_FONT);
	checkbuttonpage->no_indicator_lbl->specific.label.set_text(checkbuttonpage->no_indicator_lbl, 
			"3. CheckButtons with no indicator.");
	checkbuttonpage->no_indicator_lbl->specific.label.set_justification(checkbuttonpage->no_indicator_lbl, JUSTIFY_LEFT);
	checkbuttonpage->no_indicator_lbl->redraw(checkbuttonpage->no_indicator_lbl);

	checkbuttonpage->indicatorless_triangle = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 10, 200, 70, 30, NULL);
	checkbuttonpage->indicatorless_triangle->specific.checkbutton.set_normal_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_triangle, ui_get_pixmap(ui, TRIANGLE));
	checkbuttonpage->indicatorless_triangle->specific.checkbutton.set_selected_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_triangle, ui_get_pixmap(ui, TRIANGLE_A));
	checkbuttonpage->indicatorless_triangle->set_background_color(checkbuttonpage->indicatorless_triangle, &col);
	checkbuttonpage->indicatorless_triangle->specific.checkbutton.hide_indicator(checkbuttonpage->indicatorless_triangle);
	checkbuttonpage->indicatorless_triangle->redraw(checkbuttonpage->indicatorless_triangle);
			
	checkbuttonpage->indicatorless_squares = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 
			110, 200, 70, 30, NULL);
	checkbuttonpage->indicatorless_squares->specific.checkbutton.set_normal_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_squares, ui_get_pixmap(ui, SQUARES));
	checkbuttonpage->indicatorless_squares->specific.checkbutton.set_selected_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_squares, ui_get_pixmap(ui, SQUARES_A));
	checkbuttonpage->indicatorless_squares->set_background_color(checkbuttonpage->indicatorless_squares, &col);
	checkbuttonpage->indicatorless_squares->specific.checkbutton.hide_indicator(checkbuttonpage->indicatorless_squares);
	checkbuttonpage->indicatorless_squares->redraw(checkbuttonpage->indicatorless_squares);
	
	checkbuttonpage->indicatorless_circles = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 210, 200, 70, 30, NULL);
	checkbuttonpage->indicatorless_circles->specific.checkbutton.set_normal_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_circles, ui_get_pixmap(ui, CIRCLES));
	checkbuttonpage->indicatorless_circles->specific.checkbutton.set_selected_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_circles, ui_get_pixmap(ui, CIRCLES_A));
	checkbuttonpage->indicatorless_circles->set_background_color(checkbuttonpage->indicatorless_circles, &col);
	checkbuttonpage->indicatorless_circles->specific.checkbutton.hide_indicator(checkbuttonpage->indicatorless_circles);
	checkbuttonpage->indicatorless_circles->redraw(checkbuttonpage->indicatorless_circles);

	checkbuttonpage->indicatorless_hexagon = new_widget(CHECKBUTTON, checkbuttonpage->mainframe, 310, 200, 70, 30, NULL);
	checkbuttonpage->indicatorless_hexagon->specific.checkbutton.set_normal_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_hexagon, ui_get_pixmap(ui, HEXAGON));
	checkbuttonpage->indicatorless_hexagon->specific.checkbutton.set_selected_pixmap_from_pixmap(
			checkbuttonpage->indicatorless_hexagon, ui_get_pixmap(ui, HEXAGON_A));
	checkbuttonpage->indicatorless_hexagon->set_background_color(checkbuttonpage->indicatorless_hexagon, &col);
	checkbuttonpage->indicatorless_hexagon->specific.checkbutton.hide_indicator(checkbuttonpage->indicatorless_hexagon);
	checkbuttonpage->indicatorless_hexagon->redraw(checkbuttonpage->indicatorless_hexagon);


	checkbuttonpage->message = new_widget(LABEL, checkbuttonpage->mainframe, 10, 440, 400, 30, NULL);
	checkbuttonpage->message->specific.label.set_font(checkbuttonpage->message, SMALL_FONT);
	checkbuttonpage->message->specific.label.set_text(checkbuttonpage->message, 
			"Look at checkbuttonpage.c for the implementation of this page.");
	checkbuttonpage->message->specific.label.set_justification(checkbuttonpage->message, JUSTIFY_LEFT);
	checkbuttonpage->message->redraw(checkbuttonpage->message);

	checkbuttonpage->back = new_widget(BUTTON, checkbuttonpage->mainframe, 540, 440, 70, 30, NULL);
	checkbuttonpage->back->specific.button.set_font(checkbuttonpage->back, BOLD_FONT);
	checkbuttonpage->back->specific.button.set_text(checkbuttonpage->back, "Back");
	checkbuttonpage->back->set_border_type(checkbuttonpage->back, BEVELLED_BORDER);
	checkbuttonpage->back->specific.button.set_active_background_color(checkbuttonpage->back, &active_col);
	checkbuttonpage->back->specific.button.set_active_font_color(checkbuttonpage->back, "white");
	checkbuttonpage->back->set_background_color(checkbuttonpage->back, &col);
	checkbuttonpage->back->redraw(checkbuttonpage->back);
	checkbuttonpage->back->callbacks[BUTTON_RELEASED] = checkbuttonpage_back_released;

	return checkbuttonpage;
}

Bool checkbuttonpage_back_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ui_hide(ui, CHECKBUTTONPAGE);
	ui_show(ui, INDEXPAGE);

	return True;
}
