/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "entrypage.h"
#include "ui.h"
#include <image.h>
EntryPage* entrypage_create()
{
	int count;
	EntryPage* entrypage = (EntryPage*)malloc(sizeof(EntryPage));
	UI* ui = ui_get_ui();
	px_color active_col;

	entrypage->mainframe = new_widget(FRAME, ui->toplevel, 0, 0, 640, 480, NULL);
	entrypage->mainframe->set_background_pixmap_from_pixmap(entrypage->mainframe, ui_get_pixmap(ui, BACKGROUND));
	entrypage->mainframe->redraw(entrypage->mainframe);

	entrypage->message = new_widget(LABEL, entrypage->mainframe, 10, 10, 220, 90, NULL);
	entrypage->message->specific.label.set_font(entrypage->message, LARGE_FONT);
	entrypage->message->specific.label.set_text(entrypage->message, 
			"Experiment with the\nentry widgets below. \n(Under Development)");
	entrypage->message->redraw(entrypage->message);

	for (count = 0; count < 4; count++)
	{
		active_col.type = TRANSPARENT;
		entrypage->entries[count] = new_widget(ENTRY, entrypage->mainframe, 40, 100 + 30 * count, 90, 20, NULL);
		entrypage->entries[count]->set_background_color(entrypage->entries[count], &active_col);
		entrypage->entries[count]->specific.entry.set_font(entrypage->entries[count], NORMAL_FONT);
		entrypage->entries[count]->redraw(entrypage->entries[count]);
	}

	active_col.type = SOLID;
	widget_xcolor_from_str(&(active_col.first_color), "black");

	entrypage->back = new_widget(BUTTON, entrypage->mainframe, 10, 230, 70, 30, NULL);
	entrypage->back->specific.button.set_font(entrypage->back, BOLD_FONT);
	entrypage->back->specific.button.set_text(entrypage->back, "Back");
	entrypage->back->set_border_type(entrypage->back, BEVELLED_BORDER);
	entrypage->back->specific.button.set_active_background_color(entrypage->back, &active_col);
	entrypage->back->specific.button.set_active_font_color(entrypage->back, "white");

	active_col.type = TRANSPARENT;
	entrypage->back->set_background_color(entrypage->back, &active_col);
	entrypage->back->redraw(entrypage->back);
	entrypage->back->callbacks[BUTTON_RELEASED] = entrypage_back_released;

	return entrypage;
}

Bool entrypage_back_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ui_hide(ui, ENTRYPAGE);
	ui_show(ui, INDEXPAGE);

	return True;
}
