/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "indexpage.h"
#include "ui.h"
#include <image.h>
IndexPage* indexpage_create()
{
	IndexPage* indexpage = (IndexPage*)malloc(sizeof(IndexPage));
	UI* ui = ui_get_ui();
	px_color col, active_col;

	col.type = TRANSPARENT;
	active_col.type = SOLID;
	widget_xcolor_from_str(&(active_col.first_color), "black");
	
	indexpage->mainframe = new_widget(FRAME, ui->toplevel, 0, 0, 640, 480, NULL);
	indexpage->mainframe->set_background_pixmap_from_pixmap(indexpage->mainframe, ui_get_pixmap(ui, BACKGROUND));
	indexpage->mainframe->redraw(indexpage->mainframe);

	indexpage->heading = new_widget(LABEL, indexpage->mainframe, 10, 10, 620, 60, NULL);
	indexpage->heading->specific.label.set_font(indexpage->heading, LARGE_FONT);
	indexpage->heading->specific.label.set_text(indexpage->heading, "Widgets provided by PicoWidget.\nClick on any widget to see examples.");
	indexpage->heading->redraw(indexpage->heading);

	indexpage->container_lbl = new_widget(LABEL, indexpage->mainframe, 10, 80, 160, 30, NULL);
	indexpage->container_lbl->specific.label.set_font(indexpage->container_lbl, BOLD_FONT); 
	indexpage->container_lbl->specific.label.set_text(indexpage->container_lbl, "Container Widgets:");
	indexpage->container_lbl->specific.label.set_justification(indexpage->container_lbl, JUSTIFY_LEFT);
	indexpage->container_lbl->redraw(indexpage->container_lbl);

	indexpage->toplevels = new_widget(BUTTON, indexpage->mainframe, 25, 120, 160, 20, NULL);
	indexpage->toplevels->specific.button.set_font(indexpage->toplevels, NORMAL_FONT); 
	indexpage->toplevels->specific.button.set_text(indexpage->toplevels, "Toplevels");
	indexpage->toplevels->specific.button.set_justification(indexpage->toplevels, JUSTIFY_LEFT);
	indexpage->toplevels->set_background_color(indexpage->toplevels, &col);
	indexpage->toplevels->specific.button.set_active_background_color(indexpage->toplevels, &active_col);
	indexpage->toplevels->specific.button.set_active_font_color(indexpage->toplevels, "white");
	indexpage->toplevels->specific.button.set_disabled_font_color(indexpage->toplevels, "#ddddff");
	indexpage->toplevels->set_state(indexpage->toplevels, DISABLED);
	indexpage->toplevels->redraw(indexpage->toplevels);

	indexpage->frames = new_widget(BUTTON, indexpage->mainframe, 25, 140, 160, 20, NULL);
	indexpage->frames->specific.button.set_font(indexpage->frames, NORMAL_FONT);
	indexpage->frames->specific.button.set_text(indexpage->frames, "Frames");
	indexpage->frames->specific.button.set_justification(indexpage->frames, JUSTIFY_LEFT);
	indexpage->frames->set_background_color(indexpage->frames, &col);
	indexpage->frames->specific.button.set_active_background_color(indexpage->frames, &active_col);
	indexpage->frames->specific.button.set_active_font_color(indexpage->frames, "white");
	indexpage->frames->specific.button.set_disabled_font_color(indexpage->frames, "#ddddff");
	indexpage->frames->set_state(indexpage->frames, DISABLED);
	indexpage->frames->redraw(indexpage->frames);

	indexpage->listboxes = new_widget(BUTTON, indexpage->mainframe, 25, 160, 160, 20, NULL);
	indexpage->listboxes->specific.button.set_font(indexpage->listboxes, NORMAL_FONT);
	indexpage->listboxes->specific.button.set_text(indexpage->listboxes, "ListBoxes");
	indexpage->listboxes->specific.button.set_justification(indexpage->listboxes, JUSTIFY_LEFT);
	indexpage->listboxes->set_background_color(indexpage->listboxes, &col);
	indexpage->listboxes->specific.button.set_active_background_color(indexpage->listboxes, &active_col);
	indexpage->listboxes->specific.button.set_active_font_color(indexpage->listboxes, "white");
	indexpage->listboxes->specific.button.set_disabled_font_color(indexpage->listboxes, "#ddddff");
	indexpage->listboxes->set_state(indexpage->listboxes, DISABLED);
	indexpage->listboxes->redraw(indexpage->listboxes);


	indexpage->button_lbl = new_widget(LABEL, indexpage->mainframe, 10, 200, 160, 30, NULL);
	indexpage->button_lbl->specific.label.set_font(indexpage->button_lbl, BOLD_FONT);
	indexpage->button_lbl->specific.label.set_text(indexpage->button_lbl, "Button Widgets:");
	indexpage->button_lbl->specific.label.set_justification(indexpage->button_lbl, JUSTIFY_LEFT);
	indexpage->button_lbl->redraw(indexpage->button_lbl);

	indexpage->buttons = new_widget(BUTTON, indexpage->mainframe, 25, 240, 160, 20, NULL);
	indexpage->buttons->specific.button.set_font(indexpage->buttons, NORMAL_FONT);
	indexpage->buttons->specific.button.set_text(indexpage->buttons, "Buttons");
	indexpage->buttons->specific.button.set_justification(indexpage->buttons, JUSTIFY_LEFT);
	indexpage->buttons->set_background_color(indexpage->buttons, &col);
	indexpage->buttons->specific.button.set_active_background_color(indexpage->buttons, &active_col);
	indexpage->buttons->specific.button.set_active_font_color(indexpage->buttons, "white");
	indexpage->buttons->specific.button.set_disabled_font_color(indexpage->buttons, "#ddddff");
	indexpage->buttons->callbacks[BUTTON_RELEASED] = indexpage_button_released;
	indexpage->buttons->redraw(indexpage->buttons);

	indexpage->checkbuttons = new_widget(BUTTON, indexpage->mainframe, 25, 260, 160, 20, NULL);
	indexpage->checkbuttons->specific.button.set_font(indexpage->checkbuttons, NORMAL_FONT);
	indexpage->checkbuttons->specific.button.set_text(indexpage->checkbuttons, "CheckButtons");
	indexpage->checkbuttons->specific.button.set_justification(indexpage->checkbuttons, JUSTIFY_LEFT);
	indexpage->checkbuttons->set_background_color(indexpage->checkbuttons, &col);
	indexpage->checkbuttons->specific.button.set_active_background_color(indexpage->checkbuttons, &active_col);
	indexpage->checkbuttons->specific.button.set_active_font_color(indexpage->checkbuttons, "white");
	indexpage->checkbuttons->specific.button.set_disabled_font_color(indexpage->checkbuttons, "#ddddff");
	indexpage->checkbuttons->callbacks[BUTTON_RELEASED] = indexpage_checkbutton_released;
	indexpage->checkbuttons->redraw(indexpage->checkbuttons);

	indexpage->radiobuttons = new_widget(BUTTON, indexpage->mainframe, 25, 280, 160, 20, NULL);
	indexpage->radiobuttons->specific.button.set_font(indexpage->radiobuttons, NORMAL_FONT); 
	indexpage->radiobuttons->specific.button.set_text(indexpage->radiobuttons, "RadioButtons");
	indexpage->radiobuttons->specific.button.set_justification(indexpage->radiobuttons, JUSTIFY_LEFT);
	indexpage->radiobuttons->set_background_color(indexpage->radiobuttons, &col);
	indexpage->radiobuttons->specific.button.set_active_background_color(indexpage->radiobuttons, &active_col);
	indexpage->radiobuttons->specific.button.set_active_font_color(indexpage->radiobuttons, "white");
	indexpage->radiobuttons->specific.button.set_disabled_font_color(indexpage->radiobuttons, "#ddddff");
	indexpage->radiobuttons->callbacks[BUTTON_RELEASED] = indexpage_radiobutton_released;
	indexpage->radiobuttons->redraw(indexpage->radiobuttons);

	indexpage->textual_lbl = new_widget(LABEL, indexpage->mainframe, 310, 80, 160, 30, NULL);
	indexpage->textual_lbl->specific.label.set_font(indexpage->textual_lbl, BOLD_FONT);
	indexpage->textual_lbl->specific.label.set_text(indexpage->textual_lbl, "Textual Widgets:");
	indexpage->textual_lbl->specific.label.set_justification(indexpage->textual_lbl, JUSTIFY_LEFT);
	indexpage->textual_lbl->redraw(indexpage->textual_lbl);

	indexpage->entries = new_widget(BUTTON, indexpage->mainframe, 325, 120, 160, 20, NULL);
	indexpage->entries->specific.button.set_font(indexpage->entries, NORMAL_FONT);
	indexpage->entries->specific.button.set_text(indexpage->entries, "Entry Widgets");
	indexpage->entries->specific.button.set_justification(indexpage->entries, JUSTIFY_LEFT);
	indexpage->entries->set_background_color(indexpage->entries, &col);
	indexpage->entries->specific.button.set_active_background_color(indexpage->entries, &active_col);
	indexpage->entries->specific.button.set_active_font_color(indexpage->entries, "white");
	indexpage->entries->specific.button.set_disabled_font_color(indexpage->entries, "#ddddff");
	indexpage->entries->callbacks[BUTTON_RELEASED] = indexpage_entry_released;
	indexpage->entries->redraw(indexpage->entries);

	indexpage->labels = new_widget(BUTTON, indexpage->mainframe, 325, 140, 160, 20, NULL);
	indexpage->labels->specific.button.set_font(indexpage->labels, NORMAL_FONT);
	indexpage->labels->specific.button.set_text(indexpage->labels, "Labels");
	indexpage->labels->specific.button.set_justification(indexpage->labels, JUSTIFY_LEFT);
	indexpage->labels->set_background_color(indexpage->labels, &col);
	indexpage->labels->specific.button.set_active_background_color(indexpage->labels, &active_col);
	indexpage->labels->specific.button.set_active_font_color(indexpage->labels, "white");
	indexpage->labels->specific.button.set_disabled_font_color(indexpage->labels, "#ddddff");
	indexpage->labels->set_state(indexpage->labels, DISABLED);
	indexpage->labels->redraw(indexpage->labels);

	indexpage->message = new_widget(LABEL, indexpage->mainframe, 10, 440, 360, 30, NULL);
	indexpage->message->specific.label.set_font(indexpage->message, SMALL_FONT);
	indexpage->message->specific.label.set_text(indexpage->message, 
			"Look at indexpage.c for the implementation of this page.");
	indexpage->message->specific.label.set_justification(indexpage->message, JUSTIFY_LEFT);
	indexpage->message->redraw(indexpage->message);

	return indexpage;
}

Bool indexpage_label_pressed(px_widget* widget, px_event* event)
{
	widget->set_position(widget, widget->x+2, widget->y+2);
	widget->show(widget);
	return True;
}

Bool indexpage_mouse_enter(px_widget* widget, px_event* event)
{
	widget->set_position(widget, widget->x+2, widget->y+2);
	widget->show(widget);
	return True;
}

Bool indexpage_mouse_leave(px_widget* widget, px_event* event)
{
	widget->set_position(widget, widget->x-2, widget->y-2);
	widget->show(widget);
	return True;
}

Bool indexpage_entry_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();

	widget->set_position(widget, widget->x-2, widget->y-2);
	widget->show(widget);

	ui_hide(ui, INDEXPAGE);
	ui_show(ui, ENTRYPAGE);
	return True;
}

Bool indexpage_button_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();

	ui_hide(ui, INDEXPAGE);
	ui_show(ui, BUTTONPAGE);
	return True;
}

Bool indexpage_checkbutton_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();

	ui_hide(ui, INDEXPAGE);
	ui_show(ui, CHECKBUTTONPAGE);
	return True;
}

Bool indexpage_radiobutton_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();

	ui_hide(ui, INDEXPAGE);
	ui_show(ui, RADIOBUTTONPAGE);
	return True;
}
