/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef __INDEXPAGE_H
#define __INDEXPAGE_H

#include <picowidget.h>

typedef struct _indexpage IndexPage;

struct _indexpage
{
	px_widget* mainframe;
	px_widget* heading;
	px_widget* container_lbl;
	px_widget* button_lbl;
	px_widget* toplevels;
	px_widget* frames;
	px_widget* listboxes;
	px_widget* buttons;
	px_widget* checkbuttons;
	px_widget* radiobuttons;
	px_widget* textual_lbl, *entries, *labels;
	px_widget* message;
};

IndexPage* indexpage_create();
Bool indexpage_label_pressed(px_widget*, px_event*);
Bool indexpage_mouse_enter(px_widget*, px_event*);
Bool indexpage_mouse_leave(px_widget*, px_event*);

Bool indexpage_entry_released(px_widget*, px_event*);
Bool indexpage_button_released(px_widget*, px_event*);
Bool indexpage_checkbutton_released(px_widget*, px_event*);
Bool indexpage_radiobutton_released(px_widget*, px_event*);
#endif
