/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <picowidget.h>
#include <eventloop.h>
#include <display.h>
#include "ui.h"

int main(int argc, char **argv)
{
	char *display_name = (char *)getenv("DISPLAY");  
	px_display* display = display_get_display();

   	if (display->open_display(display, display_name)) 
   	{
		px_eventloop* eventloop;
		UI* ui = ui_get_ui();
		ui_show(ui, INDEXPAGE);
		ui->toplevel->show(ui->toplevel);

		eventloop = eventloop_get_eventloop();
		eventloop->loop(eventloop);
		picowidget_terminate();
       
   	} 
	else 
	{
      		fprintf(stderr, "%s: cannot connect to X server '%s'\n",argv[0], display_name);
      		exit(1);
   	}
   	exit(0);
}
