/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "radiobuttonpage.h"
#include "ui.h"
#include <image.h>
RadiobuttonPage* radiobuttonpage_create()
{
	int count;
	RadiobuttonPage* radiobuttonpage = (RadiobuttonPage*)malloc(sizeof(RadiobuttonPage));
	UI* ui = ui_get_ui();
	px_color col;
	px_color active_col;

	col.type = TRANSPARENT;
	active_col.type = SOLID;
	widget_xcolor_from_str(&(active_col.first_color), "black");

	radiobuttonpage->mainframe = new_widget(FRAME, ui->toplevel, 0, 0, 640, 480, NULL);
	radiobuttonpage->mainframe->set_background_pixmap_from_pixmap(radiobuttonpage->mainframe, ui_get_pixmap(ui, BACKGROUND));
	radiobuttonpage->mainframe->redraw(radiobuttonpage->mainframe);

	// Radiobuttons with text.
	radiobuttonpage->fonts_lbl = new_widget(LABEL, radiobuttonpage->mainframe, 10, 10, 320, 30, NULL);
	radiobuttonpage->fonts_lbl->specific.label.set_font(radiobuttonpage->fonts_lbl, BOLD_FONT);
	radiobuttonpage->fonts_lbl->specific.label.set_text(radiobuttonpage->fonts_lbl, "1. RadioButtons with different fonts.");
	radiobuttonpage->fonts_lbl->specific.label.set_justification(radiobuttonpage->fonts_lbl, JUSTIFY_LEFT);
	radiobuttonpage->fonts_lbl->redraw(radiobuttonpage->fonts_lbl);

	radiobuttonpage->tiny = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 10, 50, 70, 30, NULL);
	radiobuttonpage->tiny->specific.radiobutton.set_font(radiobuttonpage->tiny, TINY_FONT);
	radiobuttonpage->tiny->specific.radiobutton.set_text(radiobuttonpage->tiny, "Tiny");
	radiobuttonpage->tiny->set_background_color(radiobuttonpage->tiny, &col);
	radiobuttonpage->tiny->redraw(radiobuttonpage->tiny);
			
	radiobuttonpage->small = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 110, 50, 70, 30, NULL);
	radiobuttonpage->small->specific.radiobutton.set_font(radiobuttonpage->small, SMALL_FONT);
	radiobuttonpage->small->specific.radiobutton.set_text(radiobuttonpage->small, "Small");
	radiobuttonpage->small->specific.radiobutton.group_together(radiobuttonpage->small, radiobuttonpage->tiny);
	radiobuttonpage->small->set_background_color(radiobuttonpage->small, &col);
	radiobuttonpage->small->redraw(radiobuttonpage->small);
	
	radiobuttonpage->normal = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 210, 50, 70, 30, NULL);
	radiobuttonpage->normal->specific.radiobutton.set_font(radiobuttonpage->normal, NORMAL_FONT);
	radiobuttonpage->normal->specific.radiobutton.set_text(radiobuttonpage->normal, "Normal");
	radiobuttonpage->normal->specific.radiobutton.group_together(radiobuttonpage->normal, radiobuttonpage->tiny);
	radiobuttonpage->normal->set_background_color(radiobuttonpage->normal, &col);
	radiobuttonpage->normal->redraw(radiobuttonpage->normal);

	radiobuttonpage->bold = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 310, 50, 70, 30, NULL);
	radiobuttonpage->bold->specific.radiobutton.set_font(radiobuttonpage->bold, BOLD_FONT);
	radiobuttonpage->bold->specific.radiobutton.set_text(radiobuttonpage->bold, "Bold");
	radiobuttonpage->bold->specific.radiobutton.group_together(radiobuttonpage->bold, radiobuttonpage->tiny);
	radiobuttonpage->bold->set_background_color(radiobuttonpage->bold, &col);
	radiobuttonpage->bold->redraw(radiobuttonpage->bold);

	radiobuttonpage->large = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 410, 50, 70, 30, NULL);
	radiobuttonpage->large->specific.radiobutton.set_font(radiobuttonpage->large, LARGE_FONT);
	radiobuttonpage->large->specific.radiobutton.set_text(radiobuttonpage->large, "Large");
	radiobuttonpage->large->specific.radiobutton.group_together(radiobuttonpage->large, radiobuttonpage->tiny);
	radiobuttonpage->large->set_background_color(radiobuttonpage->large, &col);
	radiobuttonpage->large->redraw(radiobuttonpage->large);
	
	// Buttons with images.
	radiobuttonpage->images_lbl = new_widget(LABEL, radiobuttonpage->mainframe, 10, 90, 320, 30, NULL);
	radiobuttonpage->images_lbl->specific.label.set_font(radiobuttonpage->images_lbl, BOLD_FONT);
	radiobuttonpage->images_lbl->specific.label.set_text(radiobuttonpage->images_lbl, "2. RadioButtons with images.");
	radiobuttonpage->images_lbl->specific.label.set_justification(radiobuttonpage->images_lbl, JUSTIFY_LEFT);
	radiobuttonpage->images_lbl->redraw(radiobuttonpage->images_lbl);

	radiobuttonpage->triangle = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 10, 125, 70, 30, NULL);
	radiobuttonpage->triangle->specific.radiobutton.set_normal_pixmap_from_pixmap(radiobuttonpage->triangle,
			ui_get_pixmap(ui, TRIANGLE));
	radiobuttonpage->triangle->set_background_color(radiobuttonpage->triangle, &col);
	radiobuttonpage->triangle->redraw(radiobuttonpage->triangle);
			
	radiobuttonpage->squares = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 110, 125, 70, 30, NULL);
	radiobuttonpage->squares->specific.radiobutton.set_normal_pixmap_from_pixmap(radiobuttonpage->squares, 
			ui_get_pixmap(ui, SQUARES));
	radiobuttonpage->squares->specific.radiobutton.group_together(radiobuttonpage->squares, radiobuttonpage->triangle);
	radiobuttonpage->squares->set_background_color(radiobuttonpage->squares, &col);
	radiobuttonpage->squares->redraw(radiobuttonpage->squares);
	
	radiobuttonpage->circles = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 210, 125, 70, 30, NULL);
	radiobuttonpage->circles->specific.radiobutton.set_normal_pixmap_from_pixmap(radiobuttonpage->circles, 
			ui_get_pixmap(ui, CIRCLES));
	radiobuttonpage->circles->specific.radiobutton.group_together(radiobuttonpage->circles, radiobuttonpage->triangle);
	radiobuttonpage->circles->set_background_color(radiobuttonpage->circles, &col);
	radiobuttonpage->circles->redraw(radiobuttonpage->circles);

	radiobuttonpage->hexagon = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 310, 125, 70, 30, NULL);
	radiobuttonpage->hexagon->specific.radiobutton.set_normal_pixmap_from_pixmap(radiobuttonpage->hexagon, 
			ui_get_pixmap(ui, HEXAGON));
	radiobuttonpage->hexagon->specific.radiobutton.group_together(radiobuttonpage->hexagon, radiobuttonpage->triangle);
	radiobuttonpage->hexagon->set_background_color(radiobuttonpage->hexagon, &col);
	radiobuttonpage->hexagon->redraw(radiobuttonpage->hexagon);

	// Buttons with no indicator.
	radiobuttonpage->no_indicator_lbl = new_widget(LABEL, radiobuttonpage->mainframe, 10, 170, 320, 30, NULL);
	radiobuttonpage->no_indicator_lbl->specific.label.set_font(radiobuttonpage->no_indicator_lbl, BOLD_FONT);
	radiobuttonpage->no_indicator_lbl->specific.label.set_text(radiobuttonpage->no_indicator_lbl, 
			"3. RadioButtons with no indicator.");
	radiobuttonpage->no_indicator_lbl->specific.label.set_justification(radiobuttonpage->no_indicator_lbl, JUSTIFY_LEFT);
	radiobuttonpage->no_indicator_lbl->redraw(radiobuttonpage->no_indicator_lbl);

	radiobuttonpage->indicatorless_triangle = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 10, 200, 70, 30, NULL);
	radiobuttonpage->indicatorless_triangle->specific.radiobutton.set_normal_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_triangle, ui_get_pixmap(ui, TRIANGLE));
	radiobuttonpage->indicatorless_triangle->specific.radiobutton.set_selected_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_triangle, ui_get_pixmap(ui, TRIANGLE_A));
	radiobuttonpage->indicatorless_triangle->set_background_color(radiobuttonpage->indicatorless_triangle, &col);
	radiobuttonpage->indicatorless_triangle->specific.radiobutton.hide_indicator(radiobuttonpage->indicatorless_triangle);
	radiobuttonpage->indicatorless_triangle->redraw(radiobuttonpage->indicatorless_triangle);
			
	radiobuttonpage->indicatorless_squares = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 
			110, 200, 70, 30, NULL);
	radiobuttonpage->indicatorless_squares->specific.radiobutton.set_normal_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_squares, ui_get_pixmap(ui, SQUARES));
	radiobuttonpage->indicatorless_squares->specific.radiobutton.set_selected_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_squares, ui_get_pixmap(ui, SQUARES_A));
	radiobuttonpage->indicatorless_squares->set_background_color(radiobuttonpage->indicatorless_squares, &col);
	radiobuttonpage->indicatorless_squares->specific.radiobutton.hide_indicator(radiobuttonpage->indicatorless_squares);
	radiobuttonpage->indicatorless_squares->specific.radiobutton.group_together(radiobuttonpage->indicatorless_squares, 
			radiobuttonpage->indicatorless_triangle);
	radiobuttonpage->indicatorless_squares->redraw(radiobuttonpage->indicatorless_squares);
	
	radiobuttonpage->indicatorless_circles = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 210, 200, 70, 30, NULL);
	radiobuttonpage->indicatorless_circles->specific.radiobutton.set_normal_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_circles, ui_get_pixmap(ui, CIRCLES));
	radiobuttonpage->indicatorless_circles->specific.radiobutton.set_selected_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_circles, ui_get_pixmap(ui, CIRCLES_A));
	radiobuttonpage->indicatorless_circles->set_background_color(radiobuttonpage->indicatorless_circles, &col);
	radiobuttonpage->indicatorless_circles->specific.radiobutton.hide_indicator(radiobuttonpage->indicatorless_circles);
	radiobuttonpage->indicatorless_circles->specific.radiobutton.group_together(radiobuttonpage->indicatorless_circles, 
			radiobuttonpage->indicatorless_triangle);
	radiobuttonpage->indicatorless_circles->redraw(radiobuttonpage->indicatorless_circles);

	radiobuttonpage->indicatorless_hexagon = new_widget(RADIOBUTTON, radiobuttonpage->mainframe, 310, 200, 70, 30, NULL);
	radiobuttonpage->indicatorless_hexagon->specific.radiobutton.set_normal_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_hexagon, ui_get_pixmap(ui, HEXAGON));
	radiobuttonpage->indicatorless_hexagon->specific.radiobutton.set_selected_pixmap_from_pixmap(
			radiobuttonpage->indicatorless_hexagon, ui_get_pixmap(ui, HEXAGON_A));
	radiobuttonpage->indicatorless_hexagon->set_background_color(radiobuttonpage->indicatorless_hexagon, &col);
	radiobuttonpage->indicatorless_hexagon->specific.radiobutton.hide_indicator(radiobuttonpage->indicatorless_hexagon);
	radiobuttonpage->indicatorless_hexagon->specific.radiobutton.group_together(radiobuttonpage->indicatorless_hexagon, 
			radiobuttonpage->indicatorless_triangle);
	radiobuttonpage->indicatorless_hexagon->redraw(radiobuttonpage->indicatorless_hexagon);


	radiobuttonpage->message = new_widget(LABEL, radiobuttonpage->mainframe, 10, 440, 400, 30, NULL);
	radiobuttonpage->message->specific.label.set_font(radiobuttonpage->message, SMALL_FONT);
	radiobuttonpage->message->specific.label.set_text(radiobuttonpage->message, 
			"Look at radiobuttonpage.c for the implementation of this page.");
	radiobuttonpage->message->specific.label.set_justification(radiobuttonpage->message, JUSTIFY_LEFT);
	radiobuttonpage->message->redraw(radiobuttonpage->message);

	radiobuttonpage->back = new_widget(BUTTON, radiobuttonpage->mainframe, 540, 440, 70, 30, NULL);
	radiobuttonpage->back->specific.button.set_font(radiobuttonpage->back, BOLD_FONT);
	radiobuttonpage->back->specific.button.set_text(radiobuttonpage->back, "Back");
	radiobuttonpage->back->set_border_type(radiobuttonpage->back, BEVELLED_BORDER);
	radiobuttonpage->back->specific.button.set_active_background_color(radiobuttonpage->back, &active_col);
	radiobuttonpage->back->specific.button.set_active_font_color(radiobuttonpage->back, "white");
	radiobuttonpage->back->set_background_color(radiobuttonpage->back, &col);
	radiobuttonpage->back->redraw(radiobuttonpage->back);
	radiobuttonpage->back->callbacks[BUTTON_RELEASED] = radiobuttonpage_back_released;

	return radiobuttonpage;
}

Bool radiobuttonpage_back_released(px_widget* widget, px_event* event)
{
	UI* ui = ui_get_ui();
	ui_hide(ui, RADIOBUTTONPAGE);
	ui_show(ui, INDEXPAGE);

	return True;
}
