/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include "ui.h"
#include <display.h>
#include <stdlib.h>

UI* ui = NULL;
UI* ui_get_ui()
{
	if (ui == NULL)
		ui = ui_create();

	return ui;
}

UI* ui_create()
{
	int count;
	UI* ui = (UI*)malloc(sizeof(UI));
	ui->indexpage = NULL;
	ui->entrypage = NULL;
	ui->buttonpage = NULL;
	ui->checkbuttonpage = NULL;
	ui->radiobuttonpage = NULL;
	ui->toplevel = new_widget(TOPLEVEL, NULL, 0, 0, 640, 480, NULL);
	ui->toplevel->specific.toplevel.set_title(ui->toplevel, "PicoWidget Examples");
	ui->toplevel->redraw(ui->toplevel);

	for (count = 0; count < NR_IMAGES; count++)
		ui->pixmaps[count] = NULL;

	return ui;
}

void ui_show(UI* ui, Page screen)
{
	switch (screen)
	{
		case INDEXPAGE :
			if (ui->indexpage == NULL)
			{
				ui->indexpage = indexpage_create();
			}
			ui->indexpage->mainframe->show(ui->indexpage->mainframe);
			break;
		case ENTRYPAGE :
			if (ui->entrypage == NULL)
			{
				ui->entrypage = entrypage_create();
			}
			ui->entrypage->mainframe->show(ui->entrypage->mainframe);
			break;
		case BUTTONPAGE :
			if (ui->buttonpage == NULL)
			{
				ui->buttonpage = buttonpage_create();
			}
			ui->buttonpage->mainframe->show(ui->buttonpage->mainframe);
			break;
		case CHECKBUTTONPAGE :
			if (ui->checkbuttonpage == NULL)
			{
				ui->checkbuttonpage = checkbuttonpage_create();
			}
			ui->checkbuttonpage->mainframe->show(ui->checkbuttonpage->mainframe);
			break;
		case RADIOBUTTONPAGE :
			if (ui->radiobuttonpage == NULL)
			{
				ui->radiobuttonpage = radiobuttonpage_create();
			}
			ui->radiobuttonpage->mainframe->show(ui->radiobuttonpage->mainframe);
			break;

	}
}

void ui_hide(UI* ui, Page screen)
{
	switch (screen)
	{
		case INDEXPAGE :
			if (ui->indexpage != NULL)
			{
				ui->indexpage->mainframe->hide(ui->indexpage->mainframe);
			}
			break;
		case ENTRYPAGE :
			if (ui->entrypage != NULL)
			{
				ui->entrypage->mainframe->hide(ui->entrypage->mainframe);
			}
			break;
		case BUTTONPAGE :
			if (ui->buttonpage != NULL)
			{
				ui->buttonpage->mainframe->hide(ui->buttonpage->mainframe);
			}
			break;
		case CHECKBUTTONPAGE :
			if (ui->checkbuttonpage != NULL)
			{
				ui->checkbuttonpage->mainframe->hide(ui->checkbuttonpage->mainframe);
			}
			break;
		case RADIOBUTTONPAGE :
			if (ui->radiobuttonpage != NULL)
			{
				ui->radiobuttonpage->mainframe->hide(ui->radiobuttonpage->mainframe);
			}
			break;
	}
}

px_pixmap* ui_get_pixmap (UI* ui, Images pix)
{
	if (ui->pixmaps[pix] == NULL)
	{
		char pixname[100];
		pixname[0] = '\0';
		
		switch (pix)
		{
			case BACKGROUND :
				strcpy(pixname, "background");
				break;

			case TRIANGLE:
				strcpy(pixname, "triangle");
				break;

			case TRIANGLE_A:
				strcpy(pixname, "triangle_a");
				break;

			case SQUARES:
				strcpy(pixname, "squares");
				break;

			case SQUARES_A:
				strcpy(pixname, "squares_a");
				break;

			case CIRCLES:
				strcpy(pixname, "circles");
				break;
			case CIRCLES_A:
				strcpy(pixname, "circles_a");
				break;
			case HEXAGON:
				strcpy(pixname, "hexagon");
				break;
			case HEXAGON_A:
				strcpy(pixname, "hexagon_a");
				break;

			default:
				break;
		}

		if (pixname[0] != '\0')
		{
			char directory[] = "./images/";
			char* path = (char*)malloc(sizeof(char) * (strlen(directory) + strlen(pixname) + 1));
			Display* display = display_get_Xdisplay();
			strcpy(path, directory);
			strcat(path, pixname);
			
			ui->pixmaps[pix] = (px_pixmap*)malloc(sizeof(px_pixmap));

			image_initialize_pixmap(ui->pixmaps[pix]);
			image_load_file(DefaultRootWindow(display), ui->pixmaps[pix], path);
			free(path);
		}
	}

	return ui->pixmaps[pix];
}

