/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include<stdio.h>
#include<string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <pimglib.h>
#include <picowidget.h>
#include <display.h>
#include <eventloop.h>

#define TINY_FONT "-picopeta-simputer-medium-r-normal--7-*-*-*-p-*-fontspecific-0"
#define NORMAL_FONT "-picopeta-simputer-medium-r-normal--11-*-*-*-p-*-fontspecific-0"
#define BOLD_FONT 	"-picopeta-simputer-bold-r-normal--11-*-*-*-p-*-fontspecific-0"

px_display *disp;
px_eventloop *eloop;
px_widget *toplvl;
px_widget *one_rb[4], *two_rb[4];
px_widget *okbutt;
px_widget *quesn1, *quesn2;
px_color col, acol;

// Create the radiobuttons for the options of question 1
void create_one_rbs(px_widget *parent)
{
	one_rb[0] = new_widget(RADIOBUTTON, parent, 10, 55, 110, 20, "Hello");
	one_rb[0]->specific.radiobutton.set_font(one_rb[0], TINY_FONT);
	one_rb[0]->specific.radiobutton.set_text(one_rb[0], "Jawaharlal Nehru");
	one_rb[0]->specific.radiobutton.set_justification(one_rb[0], JUSTIFY_LEFT);
	one_rb[0]->redraw(one_rb[0]);
	one_rb[0]->show(one_rb[0]);

	one_rb[1] = new_widget(RADIOBUTTON, parent, 130, 55, 110, 20, "Hello");
	one_rb[1]->specific.radiobutton.set_font(one_rb[1], TINY_FONT);
	one_rb[1]->specific.radiobutton.set_text(one_rb[1], "Mahatma Gandhi");
	one_rb[1]->specific.radiobutton.set_justification(one_rb[1], JUSTIFY_LEFT);
	one_rb[1]->specific.radiobutton.group_together(one_rb[1], one_rb[0]);
	one_rb[1]->redraw(one_rb[1]);
	one_rb[1]->show(one_rb[1]);

	one_rb[2] = new_widget(RADIOBUTTON, parent, 10, 75, 110, 20, "Hello");
	one_rb[2]->specific.radiobutton.set_font(one_rb[2], TINY_FONT);
	one_rb[2]->specific.radiobutton.set_text(one_rb[2], "Netaji SC Bose");
	one_rb[2]->specific.radiobutton.set_justification(one_rb[2], JUSTIFY_LEFT);
	one_rb[2]->specific.radiobutton.group_together(one_rb[2], one_rb[0]);
	one_rb[2]->redraw(one_rb[2]);
	one_rb[2]->show(one_rb[2]);

	one_rb[3] = new_widget(RADIOBUTTON, parent, 130, 75, 110, 20, "Hello");
	one_rb[3]->specific.radiobutton.set_font(one_rb[3], TINY_FONT);
	one_rb[3]->specific.radiobutton.set_text(one_rb[3], "Nelson Mandela");
	one_rb[3]->specific.radiobutton.set_justification(one_rb[3], JUSTIFY_LEFT);
	one_rb[3]->specific.radiobutton.group_together(one_rb[3], one_rb[0]);
	one_rb[3]->redraw(one_rb[3]);
	one_rb[3]->show(one_rb[3]);
}

// Create the radiobuttons for the options of question 2
void create_two_rbs(px_widget *parent)
{
	two_rb[0] = new_widget(RADIOBUTTON, parent, 10, 160, 110, 20, "Hello");
	two_rb[0]->specific.radiobutton.set_font(two_rb[0], TINY_FONT);
	two_rb[0]->specific.radiobutton.set_text(two_rb[0], "Mahatma Gandhi");
	two_rb[0]->specific.radiobutton.set_justification(two_rb[0], JUSTIFY_LEFT);
	two_rb[0]->redraw(two_rb[0]);
	two_rb[0]->show(two_rb[0]);

	two_rb[1] = new_widget(RADIOBUTTON, parent, 130, 160, 110, 20, "Hello");
	two_rb[1]->specific.radiobutton.set_font(two_rb[1], TINY_FONT);
	two_rb[1]->specific.radiobutton.set_text(two_rb[1], "Albert Einstein");
	two_rb[1]->specific.radiobutton.set_justification(two_rb[1], JUSTIFY_LEFT);
	two_rb[1]->specific.radiobutton.group_together(two_rb[1], two_rb[0]);
	two_rb[1]->redraw(two_rb[1]);
	two_rb[1]->show(two_rb[1]);

	two_rb[2] = new_widget(RADIOBUTTON, parent, 10, 180, 110, 20, "Hello");
	two_rb[2]->specific.radiobutton.set_font(two_rb[2], TINY_FONT);
	two_rb[2]->specific.radiobutton.set_text(two_rb[2], "Indira Gandhi");
	two_rb[2]->specific.radiobutton.set_justification(two_rb[2], JUSTIFY_LEFT);
	two_rb[2]->specific.radiobutton.group_together(two_rb[2], two_rb[0]);
	two_rb[2]->redraw(two_rb[2]);
	two_rb[2]->show(two_rb[2]);

	two_rb[3] = new_widget(RADIOBUTTON, parent, 130, 180, 110, 20, "Hello");
	two_rb[3]->specific.radiobutton.set_font(two_rb[3], TINY_FONT);
	two_rb[3]->specific.radiobutton.set_text(two_rb[3], "Lokmanya Tilak");
	two_rb[3]->specific.radiobutton.set_justification(two_rb[3], JUSTIFY_LEFT);
	two_rb[3]->specific.radiobutton.group_together(two_rb[3], two_rb[0]);
	two_rb[3]->redraw(two_rb[3]);
	two_rb[3]->show(two_rb[3]);
}

// Create the questions as labels.
void create_labels(px_widget *parent)
{
	quesn1 = new_widget(LABEL, parent, 10, 5, 220, 45, NULL);
	quesn1->specific.label.set_font(quesn1, NORMAL_FONT);
	quesn1->specific.label.set_normal_color(quesn1, "#336699");
	quesn1->specific.label.set_text(quesn1, "1. An eye for an eye will make the whole world blind. Whose words are these?");
	quesn1->specific.label.set_justification(quesn1, JUSTIFY_LEFT);
	widget_set_wrap_type(quesn1, WRAP_WORD);
	quesn1->redraw(quesn1);
	quesn1->show(quesn1);

	quesn2 = new_widget(LABEL, parent, 10, 110, 220, 45, NULL);
	quesn2->specific.label.set_font(quesn2, NORMAL_FONT);
	quesn2->specific.label.set_normal_color(quesn2, "#cc9966");
	quesn2->specific.label.set_text(quesn2, "2. Who said, \"Be the change you want to see in the world\"?");
	quesn2->specific.label.set_justification(quesn2, JUSTIFY_LEFT);
	widget_set_wrap_type(quesn2, WRAP_WORD);
	quesn2->redraw(quesn2);
	quesn2->show(quesn2);
}

Bool save_rbs(px_widget *wdgt, px_event *ev)
{
	return(False);
}

// Create the OK button and associate a dummy callback
void create_buttons(px_widget *parent)
{
	okbutt = new_widget(BUTTON,parent,90,230,60,30,"Ok");
	okbutt->specific.button.set_font(okbutt, BOLD_FONT);
	okbutt->specific.button.set_text(okbutt, "Ok");
	okbutt->set_border_type(okbutt, BEVELLED_BORDER);
	okbutt->set_background_color(okbutt, &col);
	okbutt->specific.button.set_active_background_color(okbutt, &acol);
	okbutt->specific.button.set_active_font_color(okbutt, "white");
	okbutt->callbacks[BUTTON_PRESSED] = save_rbs;
	okbutt->redraw(okbutt);
	okbutt->show(okbutt);
}

int main(int av, char **ac)
{
	disp = display_get_display();
	
	if (disp->open_display(disp, (char *)getenv("DISPLAY"))) {
		col.type = TRANSPARENT;
		acol.type = SOLID;
		widget_xcolor_from_str(&acol.first_color, "black");

		// Create the toplevel window
		toplvl = new_widget(TOPLEVEL, NULL, 0, 0, 240, 270, NULL);
		toplvl->specific.toplevel.set_title(toplvl, "Example");
		toplvl->redraw(toplvl);
		toplvl->show(toplvl);

		// Create the widgets
		create_one_rbs(toplvl);
		create_two_rbs(toplvl);
		create_labels(toplvl);
		create_buttons(toplvl);

		// Get into eventloop
		eloop = eventloop_get_eventloop();
		eloop->loop(eloop);

		display_destroy();
	} else {
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
	exit(0);
}
