/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include<stdio.h>
#include<string.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <pimglib.h>
#include <picowidget.h>
#include <display.h>
#include <eventloop.h>

px_display *display;
px_eventloop *eloop;
px_widget *toplevel, *hscrollbar, *vscrollbar;

void scrollbar_change(px_widget *widget, float value)
{
#ifndef __arm__
//	printf("%s %f\n", widget->tag, value);
#endif
}

int main(int av, char **ac)
{
	display = display_get_display();
	
	if(display->open_display(display, (char *)getenv("DISPLAY"))) {
		// Create the toplevel window
		toplevel = new_widget(TOPLEVEL, NULL, 0, 0, 240, 270,"TOPLEVEL_TAG");
		toplevel->specific.toplevel.set_title(toplevel, "Example");
		toplevel->redraw(toplevel);
		toplevel->show(toplevel);

		// Create Horizontal scrollbar
		hscrollbar = new_widget(HSCROLLBAR, toplevel, 30, 30, 180, 16, NULL);
		hscrollbar->specific.hscrollbar.set_slider_position(hscrollbar, 0.0);
		hscrollbar->specific.hscrollbar.set_slider_length(hscrollbar, 0.5);
		hscrollbar->specific.hscrollbar.intimate_change = scrollbar_change;
		hscrollbar->redraw(hscrollbar);
		hscrollbar->show(hscrollbar);

		// Create Vertical scrollbar
		vscrollbar = new_widget(VSCROLLBAR, toplevel, 112, 60, 16, 180, NULL);
		vscrollbar->specific.vscrollbar.set_slider_position(vscrollbar, 0.0);
		vscrollbar->specific.vscrollbar.set_slider_length(vscrollbar, 0.3);
		vscrollbar->specific.vscrollbar.intimate_change = scrollbar_change;
		vscrollbar->redraw(vscrollbar);
		vscrollbar->show(vscrollbar);

		// Get into eventloop
		eloop = eventloop_get_eventloop();
		eloop->loop(eloop);

		display_destroy();
	} else {
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
	exit(0);
}
