/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include<stdio.h>
#include<string.h>
#include<time.h>
#include<unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include<X11/Xatom.h>
#include <pimglib.h>
#include <picowidget.h>
#include <megawidget.h>
#include <acctrl.h>
#include <display.h>
#include <eventloop.h>
#include <sys/types.h>
#include <unistd.h>

#define NORMAL_FONT      "-picopeta-simputer-medium-r-normal--11-*-*-*-p-*-fontspecific-0"
#define BOLD_FONT   "-picopeta-simputer-bold-r-normal--11-*-*-*-p-*-fontspecific-0"
#define SMALL_FONT  "-picopeta-simputer-medium-r-normal--9-*-*-*-p-*-fontspecific-0"
#define TINY_FONT   "-picopeta-simputer-medium-r-normal--7-*-*-*-p-*-fontspecific-0"
#define LARGE_FONT  "-picopeta-simputer-medium-r-normal--14-*-*-*-p-*-fontspecific-0"

px_display *display;
px_eventloop *eloop;
px_widget *toplevel, *slid;
px_color col, acol;

/*Bool slid_released (px_widget *wid, px_event *event)
{
	printf("Position %d\n",slid->specific.slider.slider_get_slider_position(slid));

	return False;
}*/
	

int main(int av, char **ac)
{
	
	display = display_get_display();
		
	if(display->open_display(display, (char *)getenv("DISPLAY"))) 
	{
		col.type = TRANSPARENT;
		acol.type = SOLID;
		widget_xcolor_from_str(&acol.first_color, "aquamarine");

		// Create the toplevel window
		toplevel = new_widget(TOPLEVEL, NULL, 0, 0, 240, 270, NULL);
		toplevel->specific.toplevel.set_title(toplevel, "Slider Example");
		toplevel->set_background_color(toplevel, &acol);
		toplevel->redraw(toplevel);
		toplevel->show(toplevel);

		slid = new_widget(VSLIDER, toplevel, 10, 50, 100, 200, "slider");
		slid->specific.vslider.set_range(slid,100,150);
		slid->specific.vslider.set_font(slid,SMALL_FONT);		
		slid->specific.vslider.show_calibration(slid,SLIDER_RIGHT);
		slid->specific.vslider.show_min_calibration(slid,False);
		slid->specific.vslider.show_value(slid,True);
		slid->specific.vslider.set_position(slid,-158);
		slid->redraw(slid);
		slid->show(slid);

		//slid->callbacks[BUTTON_RELEASED] = slid_released;

		eloop = eventloop_get_eventloop();
          eloop->loop(eloop);

		display_destroy();
	}
	else
	{
		fprintf(stderr, "Cannot open display.\n");
		exit(1);
	}
}
		
