/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <X11/Xlib.h>
#include <X11/xpm.h>
#include <math.h>

#include "picowidget.h"
#include "sktypes.h"
#include "antialias.h"

GC aa_gc;
unsigned char gauss1[64];
unsigned char gauss2[64];
XPoint point[1000];
int depth;

unsigned char brush2[] = {
     0x00, 0xfe, 0x00,
     0xfe, 0xfe, 0xfe,
     0x00, 0xfe, 0x00,
};
unsigned char brush4[] = {
     0x00, 0xfe, 0xfe, 0xfe, 0x00,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0x00, 0xfe, 0xfe, 0xfe, 0x00,
};
unsigned char brush6[] = {
     0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00
};
unsigned char brush8[] = {
     0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00,
     0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00,
     0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00,
};
unsigned char brush10[ ] = {
     0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00,
     0x00, 0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00, 0x00,
     0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00,
     0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00,
     0x00, 0x00, 0x00, 0xfe, 0xfe, 0xfe, 0xfe, 0xfe, 0x00, 0x00, 0x00,
     0x00, 0x00, 0x00, 0x00, 0x00, 0xfe, 0x00, 0x00, 0x00, 0x00, 0x00
};

static int init_gauss(float k, unsigned char *gauss_values );
static inline int put_pixel(Display *disp, frame_buffer *fb, Window win,
            int x, int y, 
            unsigned char r, unsigned char g, 
            unsigned char b, unsigned char alpha);
static inline unsigned char get_color(unsigned char bg_color, 
            unsigned char fg_color, unsigned char alpha);
static int draw_line_normal(Display *disp, frame_buffer *fb, Window win,
            int x1, int y1, int x2, int y2,
            unsigned long color, int width);
int draw_square_normal(Display *disp, frame_buffer *fb, Window win,
            int x, int y, 
            unsigned char red, unsigned char green, unsigned char blue,
            unsigned char alpha, int width);

frame_buffer *aa_get_frame_buffer(int height, int width)
{
   frame_buffer *fb = NULL;

   fb = (frame_buffer *)malloc(sizeof(frame_buffer));

   if (!fb)
      return NULL;

   fb->width = width;
   fb->height = height;
   fb->data = NULL;

   fb->data = (unsigned char *)malloc(height*width*3);
   return fb;
}

int init_antialias(Display *disp)
{
   init_gauss(3.0, gauss1);	
   init_gauss(2.0, gauss2);	
   aa_gc = XCreateGC(disp, DefaultRootWindow(disp), 0, NULL);
   depth = DefaultDepth(disp, DefaultScreen(disp));
   return 0;
}

int set_image(frame_buffer *fb, unsigned char *image, int width, int height)
{
   if (!image || !fb || !fb->data)
      return 0;

   memcpy(fb->data, image, fb->width*fb->height*3);
   return 0;
}

int aa_set_background_color(frame_buffer *fb, unsigned long color)
{
    int i;
    unsigned char *tmp;
    unsigned char r,g,b;

    if (!fb) {
       return -1;
    }

    tmp = fb->data;

    r = color >> 16;
    g = (color >> 8) & 0xff;
    b = color & 0xff;

    for (i=0; i < (fb->width*fb->height); i++) {
       tmp[0] = r;
       tmp[1] = g;
       tmp[2] = b;
       tmp += 3;
    }

    return 0;
}

static inline unsigned char get_color(unsigned char bg_color, 
                unsigned char fg_color, unsigned char alpha)
{
   unsigned short t;

   t =  ((unsigned short)alpha*(unsigned short)fg_color+
             ((unsigned short) (255-alpha))*(unsigned short) bg_color);
   return t >> 8;
}

static int init_gauss(float k, unsigned char *gauss_values)
{
   int i;
   double t, t1;

   for (i=0; i < 64; i++) {
      t = (double)i * k + 1.0;
      t = t/64.0;
      t1 = 256.0*exp(-t*t);
      gauss_values[i] = ((unsigned long) t1)&0xff;
   }
   return 0;
}

static void inline set_pixel(frame_buffer *fb, int x, int y,
                unsigned char r, unsigned char g, unsigned char b)
{
   fb->data[3*(y*fb->width+x)] = r;
   fb->data[3*(y*fb->width+x)+1] = g;
   fb->data[3*(y*fb->width+x)+2] = b;
}


static void inline get_pixel(frame_buffer *fb, int x, int y, 
                unsigned char *r, unsigned char *g, unsigned char *b)
{
   *r = fb->data[3*(y*fb->width+x)];
   *g = fb->data[3*(y*fb->width+x)+1];
   *b = fb->data[3*(y*fb->width+x)+2];
}

int free_framebuffer(frame_buffer *fb)
{
   if (!fb)
     return -1;

   if (!fb->data)
     return -1;

   free(fb->data);
   free(fb);
   return(0);
}

int aa_draw_line(Display *disp, frame_buffer *fb, Window win,
              int x, int y, int x1, int y1,
              unsigned long color, int width, char aa)
{
   int dx, dy, count, tcount;
   int e, ne, D;
   int Dtmp, index, ytmp, xmajor=1, xtmp;
   int i;
   unsigned char red, blue, green;
   int sign;

   if (!fb)
      return -1;

   if (width > 2)
      aa = 0;

   if ((x < 0) || (x1 < 0))
      return 0;

   if ((y < 0) || (y1 < 0))
      return 0;

   if ((x > fb->width) || (x1 > fb->width))
      return 0;

   if ((y > fb->height) || (y1 > fb->height))
      return 0;

   if (!aa) {
      draw_line_normal(disp, fb, win, x, y, x1, y1, color, width);
      return 0;
   }

   red = (unsigned char) (color >> 16) & 0xff;
   green = (unsigned char) (color >> 8) & 0xff;
   blue = (unsigned char) (color) & 0xff;
   dy = y1 - y;

   if (abs(x1-x) < abs(y1-y)) {
      xmajor = 0;
      xtmp = x; x = y; y = xtmp;
      xtmp = x1; x1 = y1; y1 = xtmp;
   } else {
      xmajor = 1;
   }

   count = (x1 - x);

   if (count < 0) {
      xtmp = x; x = x1; x1 = xtmp;
      ytmp = y; y = y1; y1 = ytmp;
      count = (x1 - x);
   }

   if (!count) {
      put_pixel(disp, fb, win, x, y, red, green, blue, 0xff);
      put_pixel(disp, fb, win, x-1, y-1, red, green, blue, 0xff);
      put_pixel(disp, fb, win, x-1, y, red, green, blue, 0xff);
      put_pixel(disp, fb, win, x, y-1, red, green, blue, 0xff);
      return 0;
   }

   count = x1-x;
   dy = abs(y1 - y);
   sign = (y1 - y) > 0 ? 1 : -1;

   dy = (32*dy)/count;

   if (aa) {
      dx = 32;
   } else {
      dx = count;
   }

   e = 2*dy;
   ne = 2*(dy - dx);
   D = 2*dy - dx;

   tcount = count;

   while (count > 0) {
      unsigned char t;

      if (xmajor)
         put_pixel(disp, fb, win, x, y, red, green, blue, 0xff);
      else
         put_pixel(disp, fb, win, y, x, red, green, blue, 0xff);

      x++;

      if (D > 0) {
         Dtmp = D + dx;
         index = abs(Dtmp>>1);
         ytmp = y;

         for (i=0; i<3; i++) {
            if (count == tcount) {
		
            } else if(!count) {

            }

            if (width == 1)
               t = gauss1[abs(index)];
            else
               t = gauss2[abs(index)];

            if (xmajor) {
               put_pixel(disp, fb, win, x, ytmp, red, green, blue, t);
            } else {
               put_pixel(disp, fb, win, ytmp, x, red, green, blue, t);
            }
            index -= 32;
            ytmp += sign;
         }
         y += sign;
         D += ne;
      } else {
         Dtmp = D+3*dx;
         index = abs(Dtmp >> 1);
         ytmp = y - sign;
         for (i=0; i<3; i++) {
            if(count == tcount) {

            } else if(!count) {

            }
	      
            if (width == 1)
               t = gauss1[abs(index)];
            else
               t = gauss2[abs(index)];

            if (xmajor) {
               put_pixel(disp, fb, win, x, ytmp, red, green, blue, t);
            } else {
               put_pixel(disp, fb, win, ytmp, x, red, green, blue, t);
            }
            ytmp += sign;
            index -= 32;
         }
         D += e;
      }
      count--;
   }
   if (xmajor)
      put_pixel(disp, fb, win, x, y, red, green, blue, 0xff);
   else
      put_pixel(disp, fb, win, y, x, red, green, blue, 0xff);

   return 0;
}

static int draw_line_normal(Display *disp, frame_buffer *fb, Window win,
              int x1, int y1, int x2, int y2,
              unsigned long color, int width)
{
   int deltax, deltay;
   int x,y;
   int xinc1, xinc2, yinc1, yinc2;
   int num, den;
   unsigned char red, green, blue;
   int curpixel, numpixels, numadd;

   red = (unsigned char) (color >> 16) & 0xff;
   green = (unsigned char) (color >> 8) & 0xff;
   blue = (unsigned char) (color) & 0xff;

   deltax = abs(x2 - x1);        // The difference between the x's
   deltay = abs(y2 - y1);        // The difference between the y's
   x = x1;                       // Start x off at the first pixel
   y = y1;                       // Start y off at the first pixel

   if (x2 >= x1) {                 // The x-values are increasing
      xinc1 = 1;
      xinc2 = 1;
   } else {                       // The x-values are decreasing
      xinc1 = -1;
      xinc2 = -1;
   }

   if (y2 >= y1) {                // The y-values are increasing
      yinc1 = 1;
      yinc2 = 1;
   } else {                          // The y-values are decreasing
      yinc1 = -1;
      yinc2 = -1;
   }

   if (deltax >= deltay) { // There is at least one x-value for every y-value
      xinc1 = 0;           // Don't change the x when numerator >= denominator
      yinc2 = 0;           // Don't change the y for every iteration
      den = deltax;
      num = deltax / 2;
      numadd = deltay;
      numpixels = deltax;  // There are more x-values than y-values
   } else {                // There is at least one y-value for every x-value
      xinc2 = 0;           // Don't change the x for every iteration
      yinc1 = 0;           // Don't change the y when numerator >= denominator
      den = deltay;
      num = deltay / 2;
      numadd = deltax;
      numpixels = deltay;  // There are more y-values than x-values
   }

   for (curpixel = 0; curpixel <= numpixels; curpixel++) {
      if (width == 1)
         put_pixel(disp, fb, win, x, y, red, green, blue, 0xff);
      else
         draw_square_normal(disp,fb,win,x,y,red,green,blue,0xff,width);
      num += numadd;    // Increase the numerator by the top of the fraction
      if (num >= den) { // Check if numerator >= denominator
         num -= den;    // Calculate the new numerator value
         x += xinc1;    // Change the x as appropriate
         y += yinc1;    // Change the y as appropriate
      }
      x += xinc2;       // Change the x as appropriate
      y += yinc2;       // Change the y as appropriate
   }
   return 0;
}

int draw_square_normal(Display *disp, frame_buffer *fb, Window win, 
              int x, int y,
              unsigned char red, unsigned char green, unsigned char blue, 
              unsigned char alpha, int width)
{
   int xmin, ymin;
   int i, j, numpoints=0;
   unsigned long pixel=0;
   unsigned char *brush=NULL;
   unsigned char r=red, g=green, b=blue;

   if ((x < 0) || (y < 0))
       return 0;

   if ((x > fb->width) || (y > fb->height))
       return 0;

   if (!(width & 1)) {
       width ++;
   }

   switch (width) {
      case 3 :
        brush = brush2;
        break;
      case 5 :
        brush = brush4;
        break;
      case 7 :
        brush = brush6;
        break;
      case 9 :
        brush = brush8;
        break;
      case 11 :
        brush = brush10;
        break;
      default :
        brush = brush10;
        width = 11;
        break;
   }

   if (depth == 16) {
#ifdef __arm__
      red = red >> 2;
      blue = blue >> 3;
      green = green >> 3;
      pixel = (((unsigned long)red) << 10) + 
                (((unsigned long) green) << 5) + ((unsigned long) blue);
#else 
      red = red >> 3;
      blue = blue >> 3;
      green = green >> 2;
      pixel = (((unsigned long)red) << 11) + 
                (((unsigned long) green) << 5) + ((unsigned long) blue);
#endif
   } else if (depth == 24) {
      pixel = (((unsigned long)red) << 16) + 
                (((unsigned long) green) << 8) + ((unsigned long) blue);
   } else if(depth == 4) {
      pixel = ((red + green + blue)/3) >> 4;
   } else if(depth == 12) {
      red = red >> 4;
      blue = blue >> 4;
      green = green >> 4;
      pixel = (((unsigned long)red) << 8) + 
                (((unsigned long) green) << 4) + ((unsigned long) blue);
   }

   xmin = x - ((width + 1) >> 1);
   ymin = y - ((width + 1) >> 1);

   if (xmin < 0)
      xmin = 0;

   if (ymin < 0)
      ymin = 0;

   if (xmin > fb->width)
      xmin = fb->width;

   if (ymin > fb->height)
      ymin = fb->height;

   for (i=0; i < width; i++) {
      for (j=0; j < width; j++) {
         if (brush[width*i+j]) {
            x = xmin + j;
            y = ymin + i;
            if (x < 0)
               x = 0;
            if (x > fb->width)
               x = fb->width;
            if (y < 0)
               y = 0;
            if (y > fb->height)
               y = fb->height;
            point[numpoints].x = x;
            point[numpoints++].y = y;

            set_pixel(fb, x, y, r, g, b);

            if (numpoints > 999) {
               XDrawPoints(disp,win,aa_gc,point,numpoints,CoordModeOrigin);
               numpoints = 0;
            }
         }
      }
   }

   XSetForeground(disp, aa_gc, pixel);
   XDrawPoints(disp, win, aa_gc, point, numpoints, CoordModeOrigin);
//   XFlush(disp);

   return 0;
}

static inline int put_pixel(Display *disp, frame_buffer *fb, Window win,
           int x, int y,
           unsigned char r, unsigned char g, 
           unsigned char b, unsigned char alpha)
{
   unsigned long pixel = 0;
   unsigned char br, bg, bb;
   unsigned char red, blue, green;

   if (x > fb->width)
     x = fb->width;
   if (x < 0)
     x = 0;

   if (y > fb->height)
     y = fb->height;
   if (y < 0)
     y = 0;

   get_pixel(fb, x, y, &br, &bg, &bb);

   red = get_color(br, r, alpha);
   green = get_color(bg, g, alpha);
   blue = get_color(bb, b, alpha);

   set_pixel(fb, x, y, red, green, blue);

   if (depth == 16) {
#ifdef __arm__
     red = red >> 2;
     blue = blue >> 3;
     green = green >> 3;
     pixel = (((unsigned long)red) << 10) + 
               (((unsigned long) green) << 5) + ((unsigned long) blue);
#else 
     red = red >> 3;
     blue = blue >> 3;
     green = green >> 2;
     pixel = (((unsigned long)red) << 11) + 
               (((unsigned long) green) << 5) + ((unsigned long) blue);
#endif
   } else if(depth == 24) {
     pixel = (((unsigned long)red) << 16) + 
               (((unsigned long) green) << 8) + ((unsigned long) blue);
   } else if(depth == 4) {
     pixel = ((red + green + blue)/3) >> 4;
   } else if(depth == 12) {
     red = red >> 4;
     blue = blue >> 4;
     green = green >> 4;
     pixel = (((unsigned long)red) << 8) + 
               (((unsigned long) green) << 4) + ((unsigned long) blue);
   }

   XSetForeground(disp, aa_gc, pixel);
   XDrawPoint(disp, win, aa_gc, x, y);
   return 0;
}
