/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __BUTTON_H
#define __BUTTON_H

#include "picowidget.h"

px_widget* button_create(px_widget*, int, int, int, int, const char*);
void button_set_parameters(px_widget*);
void button_set_size(px_widget* widget, unsigned long width, unsigned long height);

Bool button_default_button_press(px_widget* widget, px_event* event);
Bool button_handle_press_delay(px_widget*, px_event*);
Bool button_default_button_released(px_widget* widget, px_event* event);
Bool button_default_mouse_enter(px_widget*, px_event*);
Bool button_default_mouse_leave(px_widget*, px_event*);

void button_redraw(px_widget*);
void button_destroy(px_widget*);

void button_set_normal_pixmap_from_file(px_widget*, char*);
void button_set_active_pixmap_from_file(px_widget*, char*);
void button_set_disabled_pixmap_from_file(px_widget*, char*);

void button_set_normal_pixmap_from_pixmap(px_widget*, const px_pixmap*);
void button_set_active_pixmap_from_pixmap(px_widget*, const px_pixmap*);
void button_set_disabled_pixmap_from_pixmap(px_widget*, const px_pixmap*);

void button_set_normal_font_color(px_widget*, const char*);
void button_set_active_font_color(px_widget*, const char*);
void button_set_disabled_font_color(px_widget*, const char*);

void button_set_active_background_color(px_widget*, const px_color*);
void button_set_disabled_background_color(px_widget*, const px_color*);

void button_set_active_border_color(px_widget*, const char*);
void button_set_disabled_border_color(px_widget*, const char*);

void button_set_text(px_widget*, const char*);
void button_set_font(px_widget*, const char*);
void button_set_justification(px_widget*, justification);

justification button_get_justification(const px_widget*);
const char* button_get_text(const px_widget*);

void button_set_auto_repeat(px_widget*, Bool);
void button_set_auto_repeat_delay(px_widget*, unsigned int);
void button_set_auto_repeat_speed(px_widget*, unsigned int);

#endif

