/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __CHECKBUTTON_H
#define __CHECKBUTTON_H

#include "picowidget.h"

px_widget* checkbutton_create(px_widget*, int, int, int, int, const char*);
void checkbutton_set_parameters(px_widget* widget);
void checkbutton_set_size(px_widget* widget, unsigned long width, unsigned long height);

Bool checkbutton_default_checkbutton_pressed(px_widget* widget, px_event* event);

void checkbutton_redraw(px_widget*);
void checkbutton_destroy(px_widget*);

void checkbutton_set_normal_pixmap_from_file(px_widget*, char*);
void checkbutton_set_selected_pixmap_from_file(px_widget*, char*);
void checkbutton_set_disabled_pixmap_from_file(px_widget*, char*);

void checkbutton_set_normal_pixmap_from_pixmap(px_widget*, const px_pixmap*);
void checkbutton_set_selected_pixmap_from_pixmap(px_widget*, const px_pixmap*);
void checkbutton_set_disabled_pixmap_from_pixmap(px_widget*, const px_pixmap*);

void checkbutton_set_normal_font_color(px_widget*, const char*);
void checkbutton_set_disabled_font_color(px_widget*, const char*);

void checkbutton_set_text(px_widget*, const char*);
void checkbutton_set_font(px_widget*, const char*);
void checkbutton_set_justification(px_widget*, justification);

justification checkbutton_get_justification(const px_widget*);
const char* checkbutton_get_text(const px_widget*);

void checkbutton_show_indicator(px_widget*);
void checkbutton_hide_indicator(px_widget*);

void checkbutton_select(px_widget*);
void checkbutton_deselect(px_widget*);
#endif

