/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __COMBOBOX_H
#define __COMBOBOX_H

#include "picowidget.h"

px_widget* combobox_create(px_widget*, int, int, int, int, const char*);
void combobox_set_parameters(px_widget* widget);

void combobox_redraw(px_widget* widget);
void combobox_destroy(px_widget* widget);

int combobox_add_option(px_widget *wdgt, char * optstr, Bool redraw_flg);
int combobox_remove_option(px_widget *wdgt, int idx);
int combobox_clear_options(px_widget *wdgt);
int combobox_get_no_of_options(px_widget *wdgt);
void combobox_get_option(px_widget *wdgt, char ** option, int idx);
void combobox_get_selecn(px_widget *wdgt, char ** option, int * idx);
void combobox_set_selecn(px_widget *wdgt, int selecn);
void combobox_change_color(px_widget *wdgt, combo_colors col, char *colstr);
void combobox_set_intimate_selecn_change(px_widget *wdgt, 
		void (*change_fn)(px_widget *, int));
void combobox_set_font(px_widget* wdgt, const char *fntname);
void combobox_set_size(px_widget* wdgt, unsigned long width,
		unsigned long height);
void combobox_set_visible_num_of_options(px_widget *wdgt, int visible_num);
void combobox_disable_events(px_widget *wdgt);
void combobox_set_callback(px_widget *wdgt, widget_callbacks eventtype,
		Bool (*ev_handler)(px_widget *wdgt, px_event *ev));
XColor * combobox_get_fg_color(px_widget *wdgt);
XColor * combobox_get_bg_color(px_widget *wdgt);
char *combobox_get_fontname(px_widget *wdgt);
#endif
