/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __ENTRY_H
#define __ENTRY_H

#include "picowidget.h"
typedef enum _keysym_groups {KEYSYM_CHAR, KEYSYM_MODIFIER, KEYSYM_CURSOR, KEYSYM_UNCLASSIFIED} KeysymGroup;

px_widget* entry_create(px_widget*, int, int, int, int, const char*);
void entry_set_parameters(px_widget*);

void entry_redraw(px_widget*);
void entry_destroy(px_widget*);

void entry_cut(px_widget*, const char*);
void entry_copy(px_widget*, const char*);
void entry_paste(px_widget*, const char*);

void entry_set_foreground_color(px_widget*, const char*);
void entry_set_disabled_color(px_widget*, const char*);
void entry_set_selection_foreground_color(px_widget*, const char*);
void entry_set_selection_background(px_widget*, const px_color*);

void entry_insert_text(px_widget*, const char*, unsigned int);
void entry_set_text(px_widget*, const char*);
void entry_delete_text(px_widget*, unsigned int, unsigned int);
void entry_set_font(px_widget*, const char*);
void entry_set_focus(px_widget*, Bool);

Bool entry_default_selection_clear(px_widget*, px_event*);
Bool entry_default_button_pressed(px_widget*, px_event*);
Bool entry_default_button_released(px_widget*, px_event*);
Bool entry_default_motion(px_widget*, px_event*);
Bool entry_default_key_pressed(px_widget*, px_event*);
Bool entry_default_key_released(px_widget*, px_event*);

void entry_see(px_widget*, unsigned int);
#endif

