/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __EVENTLOOP_H
#define __EVENTLOOP_H
#include "picowidget.h"

px_eventloop* eventloop_get_eventloop();
px_eventloop* eventloop_create();

void eventloop_ignore(px_eventloop*, widget_callbacks, int);
void eventloop_grab(px_eventloop*, px_widget*);
void eventloop_focus(px_eventloop*, px_widget*);
void eventloop_register_toplevel(px_eventloop*, px_widget*);
void eventloop_remove_toplevel(px_eventloop*, px_widget*);

void eventloop_set_delay(px_eventloop*, const struct timespec*);

px_widget* eventloop_get_toplevel(px_eventloop*, Window);

px_timer* eventloop_add_timer(px_eventloop*, long, long, Bool (*function)(void*, void*), void*, void*,Bool);
px_timer* eventloop_add_timer_struct(px_eventloop* eventloop, px_timer* list_start, px_timer* timer);
void eventloop_delete_timer(px_eventloop*, px_timer*);
void eventloop_fire_timers(px_eventloop*);

void eventloop_destroy(px_eventloop*);
void eventloop_loop(px_eventloop*);
void eventloop_do_one_event(px_eventloop*);
void eventloop_handle_event(px_eventloop*, px_event*, px_widget*);
void eventloop_exit(px_eventloop*);

void eventloop_condemn(px_eventloop*, px_widget*);
#endif
