/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __FONT_H
#define __FONT_H

#include "picowidget.h"

typedef struct _font_cache FontCache;

struct _font_cache
{
	char* font_string;
	px_font* font;
	unsigned int references, lifespan;
	FontCache* next;
};

px_font* font_load_font(const char*);
void font_free_font(const char*);
void font_destroy_all();

int font_get_width(const px_font*, const char*, unsigned int);
int font_get_width_of_char(const px_font*, const char);
int font_get_height(const px_font*, const char*);

#endif
