/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __FRAME_H
#define __FRAME_H

#include "picowidget.h"

px_widget* frame_create(px_widget*, int, int, int, int, const char*);
px_widget* _frame_create(Window win, int x, int y, int width, int height, const char* tag);
void frame_set_parameters(px_widget* widget);

void frame_add_child(px_widget*, px_widget*);
void frame_remove_child(px_widget*, px_widget*);

Bool frame_handle_event(px_widget*, px_event*);
Bool frame_default_button_press(px_widget* widget, px_event* event);
Bool frame_default_button_release(px_widget* widget, px_event* event);
Bool frame_default_motion(px_widget* widget, px_event* event);
Bool frame_default_mouse_leave(px_widget* widget, px_event* event);
Bool frame_default_expose(px_widget* widget, px_event* event);

void frame_redraw(px_widget*);
void frame_show(px_widget*);
void frame_destroy(px_widget*);

void frame_cleanup_data_structures(px_widget*);
#endif

