/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __LABEL_H
#define __LABEL_H

#include "picowidget.h"

px_widget* label_create(px_widget*, int, int, int, int, const char*);
void label_set_parameters(px_widget* widget);

void label_set_size(px_widget* widget, unsigned long width, unsigned long height);

Bool label_default_button_press(px_widget* widget, px_event* event);
Bool label_default_button_released(px_widget* widget, px_event* event);
Bool label_default_mouse_enter(px_widget* widget, px_event* event);
Bool label_default_mouse_leave(px_widget* widget, px_event* event);

void label_redraw(px_widget*);
void label_show(px_widget*);
void label_destroy(px_widget*);

void label_set_normal_color(px_widget*, const char*);
void label_set_active_color(px_widget*, const char*);
void label_set_disabled_color(px_widget*, const char*);

void label_set_text(px_widget*, const char*);
void label_set_font(px_widget*, const char*);
void label_set_justification(px_widget*, justification);

justification label_get_justification(const px_widget*);
const char* label_get_text(const px_widget*);

#endif
