/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __LISTBOX_H
#define __LISTBOX_H

#include "picowidget.h"

px_widget* listbox_create(px_widget*, int, int, int, int, const char*);
void listbox_set_parameters(px_widget* widget);

Bool listbox_handle_event(px_widget*, px_event*);
Bool listbox_default_mouse_leave(px_widget*, px_event*);
Bool listbox_default_motion(px_widget*, px_event*);
Bool listbox_default_button_press(px_widget*, px_event*);
Bool listbox_default_button_release(px_widget*, px_event*);

Bool listbox_within_scrollbar(px_widget* , const px_event*);

void listbox_redraw(px_widget*);
void listbox_show(px_widget*);
void listbox_hide(px_widget*);
void listbox_destroy(px_widget*);

void listbox_inter_widget_space(px_widget*, int);

void listbox_set_child(px_widget*, px_widget*, unsigned int);
void listbox_remove_child(px_widget*, unsigned int);
px_widget* listbox_get_child(px_widget*, unsigned int);

void listbox_see(px_widget*, int);
void listbox_intimate_viewport_changed(px_widget*, float);
#endif

