/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __SKETCH_H
#define __SKETCH_H

#include "picowidget.h"

px_widget* sketch_create(px_widget* wdgt, int x, int y, int width, int height, const char* tag);
void sketch_set_parameters(px_widget* wdgt);

Bool sketch_handle_ev(px_widget* wdgt, px_event* ev);
Bool sketch_dflt_motion(px_widget* wdgt, px_event* ev);
Bool sketch_dflt_bpress(px_widget* wdgt, px_event* ev);
Bool sketch_dflt_brelease(px_widget* wdgt, px_event* ev);

void sketch_redraw(px_widget* wdgt);
void sketch_show(px_widget* wdgt);
void sketch_destroy(px_widget* wdgt);

void sketch_set_pen_width(px_widget *wdgt, unsigned int penwid);
void sketch_set_pen_color(px_widget *wdgt, unsigned long pen_col);
void sketch_clear_widget(px_widget *wdgt);

int sketch_load_from_file(px_widget *wdgt, const char *fname);
int sketch_save_to_file(px_widget *wdgt, const char *fname);
int sketch_load_from_buffer(px_widget *wdgt, char *buff, int buff_sz);
int sketch_save_to_buffer(px_widget *wdgt, char **buff);

void sketch_set_type(px_widget *wdgt, sketch_type type);

unsigned int sketch_get_pen_width(px_widget *wdgt);
unsigned long sketch_get_pen_color(px_widget *wdgt);
unsigned long sketch_get_bg_color(px_widget *wdgt);

#endif
