/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#define END_CHAR -128
#define ID_LEN 10
#define MAX_SCRIPT_SIZE 200
#define STIP_WIDTH 4
#define STIP_HEIGHT 4

typedef struct _motion_node motion_node;
typedef struct _stroke_node stroke_node;
typedef struct _color_node color_node;
typedef struct _frame_buffer frame_buffer;
typedef struct _sketch_data sketch_data;

struct _motion_node {
	int n_pts;
	int dx_dy[MAX_SCRIPT_SIZE];
	motion_node *next;
};

struct _stroke_node {
	char id[ID_LEN+1];
	int x, y;
	short int width;
	Bool stipple;
	unsigned int color;
	short int col_code;
	motion_node *stroke_head;
	motion_node *stroke_tail;
	stroke_node *next;
	stroke_node *prev;
};

struct _color_node {
	short int col_code;
	unsigned int color;
	color_node *next;
};

struct _frame_buffer {
	unsigned char *data;
	int width;
	int height;
};

struct _sketch_data {
	frame_buffer *fb;
	GC mgc;
	sketch_type sktype;

	unsigned long bg_col;
	unsigned long bg_col_pixel;
	unsigned long pen_col;
	unsigned int pen_wid;
	int curr_x, curr_y;
	Time curr_time;
	stroke_node *first_stroke, *last_stroke;
	color_node *first_col;
};
