/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __TABS_H
#define __TABS_H

#include "picowidget.h"

typedef struct _pwtabinfo pw_tab;
typedef struct _px_tab_holder px_tab_holder;

struct _pwtabinfo {
        px_widget* content_frame;
        px_widget* event_within;
        px_pixmap *normal_pixmap;
        px_pixmap *active_pixmap;
        unsigned int ends_at;
        px_widget **widget_list;
        unsigned int no_of_children;
        unsigned int allocated;
	int prev_selected;
        int widget_selected;
        px_tab_holder **tablist;
};

struct _px_tab_holder {
    int xend_position;
    int tab_position;
    char *tab_title;
    Bool (*callbacks)(px_widget *widget, px_event *event);
};
void redraw_entire_tab(px_widget *widget);

// px_widget* tab_create(px_widget*, int no_of_tabs, char **title_list, int frame_width, int frame_height,
//                      int x, int y, int width_of_tab, widget_side side);
px_widget* tab_create(px_widget*, int x , int y, int width, int height, const char* tag);
px_widget* tab_add_tab(px_widget *widget, const char *, Bool(*tab_callback)(px_widget*, px_event*));
// void tab_delete_tab(int position);
// void tab_add_tab_at(int position);
// void tab_move_tab(int oldpos, int newpos);
void tab_raise_tab(px_widget *widget, int position);
// void tab_change_title(int position, char *new_title);
// void tab_show_tab(int position);
// void tab_hide_tab(int position);
// void tab_change_image(int position, char *pixmap_path);
// void tab_show_delete(int position);
// void tab_show_delete_all();
void tab_set_size (px_widget* widget, unsigned long width, unsigned long height);
Bool tab_default_button_released(px_widget* widget, px_event *event);
Bool tab_default_button_pressed(px_widget *widget, px_event *event);
Bool tab_handle_event(px_widget* widget, px_event* event);
void tab_redraw(px_widget* widget);
void tab_destroy(px_widget* widget);
void redraw_tabs( px_widget *widget, px_tab *tab, int prev_tab, int act_tab);
px_widget *tab_get_widget_pointer(px_widget *widget, int tabnumber);
px_widget *tab_get_active_widget(px_widget *widget);

#endif

