/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __TEXT_H
#define __TEXT_H

#include "picowidget.h"
#include "font.h"
#include "image.h"
#include "eventloop.h"
#include "display.h"
#include "theme.h"
#include "widget_factory.h"

#include <X11/extensions/shape.h>
#define XK_MISCELLANY
#define XK_LATIN1
#include <X11/keysymdef.h>
#include <X11/Xlib.h>
#include <X11/Xatom.h>
#include <X11/Xutil.h>

#include <stdlib.h>
#include <string.h>

px_widget* text_create(px_widget*, int, int, int, int, const char*);
void text_set_focus(px_widget*, Bool);
void text_set_parameters(px_widget*);

void text_redraw(px_widget* widget);
void text_destroy(px_widget* widget);
void text_set_font(px_widget* widget, const char *fontname);
void text_set_wrap_type(px_widget* widget, unsigned wrap_type);
void text_set_foreground_color(px_widget* widget, const char *color);
int text_load_file(px_widget* widget, const char *filename);
int text_save_file(px_widget* widget, const char *filename);
int text_get_numlines(px_widget *widget);
const char *text_get_line(px_widget *widget, unsigned linenum);
char *text_get_text(px_widget *widget);
int text_set_text(px_widget *widget, const char *text);
void text_set_focus(px_widget* widget, Bool set);

Bool text_default_button_pressed(px_widget* widget, px_event* event);
Bool text_default_button_released(px_widget* widget, px_event* event);
Bool text_default_motion(px_widget* widget, px_event* event);
Bool text_default_key_pressed(px_widget* widget, px_event* event);
Bool text_default_key_released(px_widget* widget, px_event* event);
#endif

