/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __TOPLEVEL_H
#define __TOPLEVEL_H

#include "picowidget.h"

px_widget* toplevel_create(int, int, int, int, const char*);
void toplevel_set_parameters(px_widget* widget);

void toplevel_add_child(px_widget*, px_widget*);
void toplevel_remove_child(px_widget*, px_widget*);

Bool toplevel_handle_event(px_widget*, px_event*);
Bool toplevel_default_button_press(px_widget* widget, px_event* event);
Bool toplevel_default_button_release(px_widget* widget, px_event* event);
Bool toplevel_default_motion(px_widget* widget, px_event* event);
Bool toplevel_default_mouse_leave(px_widget* widget, px_event* event);
Bool toplevel_default_expose(px_widget* widget, px_event* event);
Bool toplevel_default_client_message(px_widget* widget, px_event* event);
Bool toplevel_default_configure_event(px_widget* widget, px_event* event);

void toplevel_redraw(px_widget*);
void toplevel_show(px_widget*);
void toplevel_destroy(px_widget*);

void toplevel_set_title(px_widget*, const char*);
void toplevel_cleanup_data_structures(px_widget* widget);
#endif

