/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __TXTLB_H
#define __TXTLB_H

#include "picowidget.h"

px_widget* txtlb_create(px_widget* wdgt, int x, int y, int width, int height, const char* tag);
void txtlb_set_parameters(px_widget* wdgt);

Bool txtlb_handle_ev(px_widget* wdgt, px_event* ev);
Bool txtlb_dflt_motion(px_widget* wdgt, px_event* ev);
Bool txtl_dflt_bpress(px_widget* wdgt, px_event* ev);
Bool txtlb_dflt_brelease(px_widget* wdgt, px_event* ev);

void txtlb_redraw(px_widget* wdgt);
void txtlb_show(px_widget* wdgt);
void txtlb_destroy(px_widget* wdgt);
void txtlb_set_size(px_widget* widget, unsigned long width,
		unsigned long height);

int add_lb_column(px_widget* wdgt, int wid);
int add_lb_elem(px_widget* wdgt, char *txtstr, int colnum);
int change_lb_elem(px_widget *wdgt, char *txtstr, int colnum, int rowidx);
int remove_lb_row(px_widget *wdgt, int rowidx, Bool redraw_flg);

void txtlb_set_intimate_change(px_widget *wdgt, 
		void (*change_fn)(px_widget *, int));
void txtlb_set_view(px_widget *wdgt, int sidx);
void txtlb_set_font(px_widget *wdgt, const char *fnt_name);
void txtlb_set_selection(px_widget *wdgt, int sel_idx);
int txtlb_clear_all_rows(px_widget *wdgt);
void txtlb_set_type(px_widget *wdgt, txtlb_types type);

int txtlb_get_selecn(px_widget *wdgt);
int txtlb_get_all_selecn(px_widget *wdgt, int ** selecn_arr);
int txtlb_get_no_of_rows(px_widget *wdgt);
void txtlb_get_element(px_widget *wdgt, char **str, int idx, int colnum);
unsigned long txtlb_get_bg_color(px_widget *wdgt);
unsigned long txtlb_get_fg_color(px_widget *wdgt);
void txtlb_set_intimate_view_change(px_widget *wdgt, 
		void (*change_fn)(px_widget *, int));
void txtlb_get_view_port(px_widget *wdgt, int *sidx, int *eidx);
void txtlb_set_visible_no_of_rows(px_widget *wdgt, int num);

#endif
