/*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
// (C) PicoPeta Simputers Pvt. Ltd. (2003)
// Author: Santhosh N

#ifndef __VSCROLLBAR_H
#define __VSCROLLBAR_H

#include "picowidget.h"

px_widget* vscrollbar_create(px_widget*, int, int, int, int, const char*);
void vscrollbar_set_parameters(px_widget* widget);

Bool vscrollbar_default_button_press(px_widget*, px_event*);
Bool vscrollbar_default_button_release(px_widget*, px_event*);
Bool vscrollbar_default_button_motion(px_widget*, px_event*);

void vscrollbar_redraw(px_widget*);
void vscrollbar_destroy(px_widget*);

void vscrollbar_set_slider_position(px_widget*, float);
void vscrollbar_set_slider_length(px_widget*, float);

void vscrollbar_set_increment(px_widget*, float);

float vscrollbar_get_slider_position(px_widget* widget);
float vscrollbar_get_increment(px_widget* widget);

void vscrollbar_redraw_slider(px_widget*);
void vscrollbar_redraw_top_button(px_widget*);
void vscrollbar_redraw_bottom_button(px_widget*);

#endif

